#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>

#include "TTree.h"
#include "TFile.h"
#include "TString.h"

#include "TSystem.h"
#include "THaEvent.h"
#include "THaRun.h"
#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"
#include "TStyle.h"
#include "TChain.h"
#include "TEllipse.h"
#include "TLine.h"
#include "TMarker.h"



using namespace std;

void GoodEventProducerTest(int runnumber=0, double BBangle=-75.0 * 3.141592654/180.0, double MAXnum=-1)
{

  TString outFileName;
  outFileName.Form("./ROOTResults/eed_Test_GoodEvents_%d.root",runnumber);

  TFile *fout = new TFile(outFileName,"RECREATE");

  TTree *tout = new TTree("tout","Tree with Results");
  tout->SetDirectory(fout);

  double in2m = 0.0254;

  Double_t DL_evtypebits;
  Double_t L_gold_dp;
  Double_t L_gold_th;
  Double_t L_gold_y;
  Double_t L_gold_ph;
  Double_t L_gold_p;
  Double_t PriKineLHe3_q_x;
  Double_t PriKineLHe3_q_y;
  Double_t PriKineLHe3_q_z;
  Double_t BB_tr_n;
  Double_t BB_gold_y;
  Double_t BB_gold_index;
  Double_t BB_gold_th;
  Double_t BB_gold_ph;
  Double_t BB_gold_dp;
  Double_t BB_gold_p;
  Double_t BB_gold_px;
  Double_t BB_gold_py;
  Double_t BB_gold_pz;
  Double_t BB_tr_x[100];
  Double_t BB_tr_y[100];
  Double_t BB_tr_th[100];
  Double_t BB_tr_ph[100];
  Double_t DL_t3[100];
  Double_t ReactPt_L_z;
  Double_t BB_tp_de_LA[24];
  Double_t BB_tp_de_RA[24];
  Double_t BB_tp_e_LA[24];
  Double_t BB_tp_e_RA[24];  
  Double_t BB_tp_de_hit_bar[100];
  Double_t BB_tp_e_hit_bar[100];
  Double_t BB_tp_de_nhit;
  Double_t BB_tp_e_nhit;
  Double_t BB_tp_hit_xpos[100];
  Double_t BB_tp_hit_ypos[100];
  Double_t BB_tp_trx[100];
  Double_t BB_tp_try[100];
  Double_t BB_tp_trHitIndex[100];

  Double_t BB_tp_de_LApedc[24];
  Double_t BB_tp_de_RApedc[24];
  Double_t BB_tp_e_LApedc[24];
  Double_t BB_tp_e_RApedc[24];  
  Double_t BB_tp_de_LE[24];
  Double_t BB_tp_de_RE[24];
  Double_t BB_tp_e_LE[24];
  Double_t BB_tp_e_RE[24];  

  Double_t rb_x;
  Double_t rb_y;

  Int_t Ndata_BB_tr_x;
  Int_t Ndata_BB_tr_y;
  Int_t Ndata_BB_tr_th;
  Int_t Ndata_BB_tr_ph;
  Int_t Ndata_DL_t3;
  Int_t Ndata_BB_tp_de_LA;
  Int_t Ndata_BB_tp_de_RA;
  Int_t Ndata_BB_tp_e_LA;
  Int_t Ndata_BB_tp_e_RA;  
  Int_t Ndata_BB_tp_de_hit_bar;
  Int_t Ndata_BB_tp_e_hit_bar;
  Int_t Ndata_BB_tp_hit_xpos;
  Int_t Ndata_BB_tp_hit_ypos;
  Int_t Ndata_BB_tp_trx;
  Int_t Ndata_BB_tp_try;
  Int_t Ndata_BB_tp_trHitIndex;

  Int_t Ndata_BB_tp_de_LApedc;
  Int_t Ndata_BB_tp_de_RApedc;
  Int_t Ndata_BB_tp_e_LApedc;
  Int_t Ndata_BB_tp_e_RApedc;  
  Int_t Ndata_BB_tp_de_LE;
  Int_t Ndata_BB_tp_de_RE;
  Int_t Ndata_BB_tp_e_LE;
  Int_t Ndata_BB_tp_e_RE;  


  double scattering_angle = BBangle; 

  TChain *t1 =new TChain("T");


  TString filename="";
  filename.Form("./ROOTfiles/eed_test_rootfile_%d.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_1.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_2.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_3.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_4.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_5.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_6.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_7.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_8.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_9.root", runnumber);
  t1->Add(filename);
  filename.Form("./ROOTfiles/eed_test_rootfile_%d_10.root", runnumber);
  t1->Add(filename);


  assert(t1);


  t1->SetBranchAddress( "DL.evtypebits", &DL_evtypebits);
  t1->SetBranchAddress( "DL.t3", &DL_t3);
  t1->SetBranchAddress( "L.gold.dp", &L_gold_dp);
  t1->SetBranchAddress( "L.gold.th", &L_gold_th);
  t1->SetBranchAddress( "L.gold.ph", &L_gold_ph);
  t1->SetBranchAddress( "L.gold.y", &L_gold_y);
  t1->SetBranchAddress( "L.gold.p", &L_gold_p);
  t1->SetBranchAddress( "BB.gold.y", &BB_gold_y);
  t1->SetBranchAddress( "BB.gold.th", &BB_gold_th);
  t1->SetBranchAddress( "BB.gold.ph", &BB_gold_ph);
  t1->SetBranchAddress( "BB.gold.dp", &BB_gold_dp);
  t1->SetBranchAddress( "BB.gold.p", &BB_gold_p);
  t1->SetBranchAddress( "BB.gold.px", &BB_gold_px);
  t1->SetBranchAddress( "BB.gold.py", &BB_gold_py);
  t1->SetBranchAddress( "BB.gold.pz", &BB_gold_pz);
  t1->SetBranchAddress( "BB.tr.n", &BB_tr_n);
  t1->SetBranchAddress( "BB.tr.x", &BB_tr_x);
  t1->SetBranchAddress( "BB.tr.y", &BB_tr_y);
  t1->SetBranchAddress( "BB.tr.th", &BB_tr_th);
  t1->SetBranchAddress( "BB.tr.ph", &BB_tr_ph);
  t1->SetBranchAddress( "BB.tp.trHitIndex", &BB_tp_trHitIndex);
  t1->SetBranchAddress( "BB.tp.e.hit_bar", &BB_tp_e_hit_bar);
  t1->SetBranchAddress( "BB.tp.de.hit_bar", &BB_tp_de_hit_bar);
  t1->SetBranchAddress( "BB.gold.index", &BB_gold_index);
  t1->SetBranchAddress( "BB.tp.e.LA", &BB_tp_e_LA);
  t1->SetBranchAddress( "BB.tp.e.RA", &BB_tp_e_RA);
  t1->SetBranchAddress( "BB.tp.de.LA", &BB_tp_de_LA);
  t1->SetBranchAddress( "BB.tp.de.RA", &BB_tp_de_RA);
  t1->SetBranchAddress( "BB.tp.de.nhit", &BB_tp_de_nhit);
  t1->SetBranchAddress( "BB.tp.e.nhit", &BB_tp_e_nhit);
  t1->SetBranchAddress( "BB.tp.hit_xpos", &BB_tp_hit_xpos);
  t1->SetBranchAddress( "BB.tp.hit_ypos", &BB_tp_hit_ypos);
  t1->SetBranchAddress( "BB.tp.trx", &BB_tp_trx);
  t1->SetBranchAddress( "BB.tp.try", &BB_tp_try); 

  t1->SetBranchAddress( "ReactPt_L.z", &ReactPt_L_z);
  t1->SetBranchAddress( "rb.x", &rb_x);
  t1->SetBranchAddress( "rb.y", &rb_y);

  t1->SetBranchAddress( "PriKineLHe3.q_x", &PriKineLHe3_q_x);
  t1->SetBranchAddress( "PriKineLHe3.q_y", &PriKineLHe3_q_y);
  t1->SetBranchAddress( "PriKineLHe3.q_z", &PriKineLHe3_q_z);
  
  t1->SetBranchAddress( "BB.tp.de.LApedc", &BB_tp_de_LApedc);
  t1->SetBranchAddress( "BB.tp.de.RApedc", &BB_tp_de_RApedc);
  t1->SetBranchAddress( "BB.tp.e.LApedc", &BB_tp_e_LApedc);
  t1->SetBranchAddress( "BB.tp.e.RApedc", &BB_tp_e_RApedc);
  t1->SetBranchAddress( "BB.tp.de.LE", &BB_tp_de_LE);
  t1->SetBranchAddress( "BB.tp.de.RE", &BB_tp_de_RE);
  t1->SetBranchAddress( "BB.tp.e.LE", &BB_tp_e_LE);
  t1->SetBranchAddress( "BB.tp.e.RE", &BB_tp_e_RE);
  

  t1->SetBranchAddress( "Ndata.DL.t3", &Ndata_DL_t3);
  t1->SetBranchAddress( "Ndata.BB.tr.x", &Ndata_BB_tr_x);
  t1->SetBranchAddress( "Ndata.BB.tr.y", &Ndata_BB_tr_y);
  t1->SetBranchAddress( "Ndata.BB.tr.th", &Ndata_BB_tr_th);
  t1->SetBranchAddress( "Ndata.BB.tr.ph", &Ndata_BB_tr_ph);
  t1->SetBranchAddress( "Ndata.BB.tp.trHitIndex", &Ndata_BB_tp_trHitIndex);
  t1->SetBranchAddress( "Ndata.BB.tp.e.hit_bar", &Ndata_BB_tp_e_hit_bar);
  t1->SetBranchAddress( "Ndata.BB.tp.de.hit_bar", &Ndata_BB_tp_de_hit_bar);
  t1->SetBranchAddress( "Ndata.BB.tp.e.LA", &Ndata_BB_tp_e_LA);
  t1->SetBranchAddress( "Ndata.BB.tp.e.RA", &Ndata_BB_tp_e_RA);
  t1->SetBranchAddress( "Ndata.BB.tp.de.LA", &Ndata_BB_tp_de_LA);
  t1->SetBranchAddress( "Ndata.BB.tp.de.RA", &Ndata_BB_tp_de_RA);
  t1->SetBranchAddress( "Ndata.BB.tp.hit_xpos", &Ndata_BB_tp_hit_xpos);
  t1->SetBranchAddress( "Ndata.BB.tp.hit_ypos", &Ndata_BB_tp_hit_ypos);
  t1->SetBranchAddress( "Ndata.BB.tp.trx", &Ndata_BB_tp_trx);
  t1->SetBranchAddress( "Ndata.BB.tp.try", &Ndata_BB_tp_try); 

  t1->SetBranchAddress( "Ndata.BB.tp.de.LApedc", &Ndata_BB_tp_de_LApedc);
  t1->SetBranchAddress( "Ndata.BB.tp.de.RApedc", &Ndata_BB_tp_de_RApedc);
  t1->SetBranchAddress( "Ndata.BB.tp.e.LApedc", &Ndata_BB_tp_e_LApedc);
  t1->SetBranchAddress( "Ndata.BB.tp.e.RApedc", &Ndata_BB_tp_e_RApedc);
  t1->SetBranchAddress( "Ndata.BB.tp.de.LE", &Ndata_BB_tp_de_LE);
  t1->SetBranchAddress( "Ndata.BB.tp.de.RE", &Ndata_BB_tp_de_RE);
  t1->SetBranchAddress( "Ndata.BB.tp.e.LE", &Ndata_BB_tp_e_LE);
  t1->SetBranchAddress( "Ndata.BB.tp.e.RE", &Ndata_BB_tp_e_RE);
  


  tout->Branch("L.gold.y", &L_gold_y,"L.gold.y/D");
  tout->Branch("L.gold.ph", &L_gold_ph,"L.gold.ph/D");
  tout->Branch("L.gold.th", &L_gold_th,"L.gold.th/D");
  tout->Branch("L.gold.dp", &L_gold_dp,"L.gold.dp/D");
  tout->Branch("L.gold.p", &L_gold_p,"L.gold.p/D");

  tout->Branch("BB.tr.n", &BB_tr_n,"BB.tr.n/D");
  tout->Branch("Ndata.BB.tr.x", &Ndata_BB_tr_x,"Ndata.BB.tr.x/I");
  tout->Branch("BB.tr.x", &BB_tr_x,"BB.tr.x[Ndata.BB.tr.x]/D");
  tout->Branch("Ndata.BB.tr.y", &Ndata_BB_tr_y,"Ndata.BB.tr.y/I");
  tout->Branch("BB.tr.y", &BB_tr_y,"BB.tr.y[Ndata.BB.tr.y]/D");
  tout->Branch("Ndata.BB.tr.th", &Ndata_BB_tr_th,"Ndata.BB.tr.th/I");
  tout->Branch("BB.tr.th", &BB_tr_th,"BB.tr.th[Ndata.BB.tr.th]/D");
  tout->Branch("Ndata.BB.tr.ph", &Ndata_BB_tr_ph,"Ndata.BB.tr.ph/I");
  tout->Branch("BB.tr.ph", &BB_tr_ph,"BB.tr.ph[Ndata.BB.tr.ph]/D");
  tout->Branch("BB.gold.y", &BB_gold_y,"BB.gold.y/D");
  tout->Branch("BB.gold.ph", &BB_gold_ph,"BB.gold.ph/D");
  tout->Branch("BB.gold.th", &BB_gold_th,"BB.gold.th/D");
  tout->Branch("BB.gold.dp", &BB_gold_dp,"BB.gold.dp/D");
  tout->Branch("BB.gold.p", &BB_gold_p,"BB.gold.p/D");
  tout->Branch("BB.gold.px", &BB_gold_px,"BB.gold.px/D");
  tout->Branch("BB.gold.py", &BB_gold_py,"BB.gold.py/D");
  tout->Branch("BB.gold.pz", &BB_gold_pz,"BB.gold.pz/D");
  tout->Branch( "BB.gold.index", &BB_gold_index,"BB.gold.index/D");
  tout->Branch("PriKineLHe3.q_z", &PriKineLHe3_q_z,"PriKineLHe3.q_z/D");
  tout->Branch("PriKineLHe3.q_y", &PriKineLHe3_q_y,"PriKineLHe3.q_y/D");
  tout->Branch("PriKineLHe3.q_x", &PriKineLHe3_q_x,"PriKineLHe3.q_x/D");
  tout->Branch("Ndata.DL.t3", &Ndata_DL_t3,"Ndata.DL.t3/I");
  tout->Branch("DL.t3", &DL_t3,"DL.t3[Ndata.DL.t3]/D");
  tout->Branch("ReactPt_L.z", &ReactPt_L_z,"ReactPt_L.z/D");
  tout->Branch("rb.x", &rb_x,"rb.x/D");
  tout->Branch("rb.y", &rb_y,"rb.y/D");
  tout->Branch("scattering_angle", &scattering_angle," scattering_angle/D");


  tout->Branch("Ndata.BB.tp.trHitIndex", &Ndata_BB_tp_trHitIndex,"Ndata.BB.tp.trHitIndex/I");
  tout->Branch( "BB.tp.trHitIndex", &BB_tp_trHitIndex,"BB.tp.trHitIndex[Ndata.BB.tp.trHitIndex]/D");

  tout->Branch("Ndata.BB.tp.e.hit_bar", &Ndata_BB_tp_e_hit_bar,"Ndata.BB.tp.e.hit_bar/I");
  tout->Branch( "BB.tp.e.hit_bar", &BB_tp_e_hit_bar,"BB.tp.e.hit_bar[Ndata.BB.tp.e.hit_bar]/D");

  tout->Branch("Ndata.BB.tp.de.hit_bar", &Ndata_BB_tp_de_hit_bar,"Ndata.BB.tp.de.hit_bar/I");
  tout->Branch("BB.tp.de.hit_bar", &BB_tp_de_hit_bar,"BB.tp.de.hit_bar[Ndata.BB.tp.de.hit_bar]/D");

  tout->Branch("Ndata.BB.tp.e.LA", &Ndata_BB_tp_e_LA,"Ndata.BB.tp.e.LA/I");  
  tout->Branch("BB.tp.e.LA",&BB_tp_e_LA, "BB.tp.e.LA[Ndata.BB.tp.e.LA]/D");
  tout->Branch("Ndata.BB.tp.e.RA", &Ndata_BB_tp_e_RA,"Ndata.BB.tp.e.RA/I");
  tout->Branch( "BB.tp.e.RA", &BB_tp_e_RA,"BB.tp.e.RA[Ndata.BB.tp.e.RA]/D");

  tout->Branch("Ndata.BB.tp.de.LA", &Ndata_BB_tp_de_LA,"Ndata.BB.tp.de.LA/I");
  tout->Branch( "BB.tp.de.LA", &BB_tp_de_LA,"BB.tp.de.LA[Ndata.BB.tp.de.LA]/D");
  tout->Branch("Ndata.BB.tp.de.RA", &Ndata_BB_tp_de_RA,"Ndata.BB.tp.de.RA/I");
  tout->Branch( "BB.tp.de.RA", &BB_tp_de_RA, "BB.tp.de.RA[Ndata.BB.tp.de.RA]/D");

  tout->Branch( "BB.tp.de.nhit", &BB_tp_de_nhit,"BB.tp.de.nhit/D");
  tout->Branch( "BB.tp.e.nhit", &BB_tp_e_nhit,"BB.tp.e.nhit/D");

  tout->Branch("Ndata.BB.tp.hit_xpos", &Ndata_BB_tp_hit_xpos,"Ndata.BB.tp.hit_xpos/I");
  tout->Branch( "BB.tp.hit_xpos", &BB_tp_hit_xpos, "BB.tp.hit_xpos[Ndata.BB.tp.hit_xpos]/D");

  tout->Branch("Ndata.BB.tp.hit_ypos", &Ndata_BB_tp_hit_ypos,"Ndata.BB.tp.hit_ypos/I");
  tout->Branch( "BB.tp.hit_ypos", &BB_tp_hit_ypos,"BB.tp.hit_ypos[Ndata.BB.tp.hit_ypos]/D");
  
  tout->Branch("Ndata.BB.tp.trx", &Ndata_BB_tp_trx,"Ndata.BB.tp.trx/I");
  tout->Branch( "BB.tp.trx", &BB_tp_trx,"BB.tp.trx[Ndata.BB.tp.trx]/D");

  tout->Branch("Ndata.BB.tp.try", &Ndata_BB_tp_try,"Ndata.BB.tp.try/I");
  tout->Branch( "BB.tp.try", &BB_tp_try,"BB.tp.try[Ndata.BB.tp.try]/D");


  tout->Branch("Ndata.BB.tp.de.LApedc", &Ndata_BB_tp_de_LApedc,"Ndata.BB.tp.de.LApedc/I");
  tout->Branch( "BB.tp.de.LApedc", &BB_tp_de_LApedc,"BB.tp.de.LApedc[Ndata.BB.tp.de.LApedc]/D");
  tout->Branch("Ndata.BB.tp.de.RApedc", &Ndata_BB_tp_de_RApedc,"Ndata.BB.tp.de.RApedc/I");
  tout->Branch( "BB.tp.de.RApedc", &BB_tp_de_RApedc, "BB.tp.de.RApedc[Ndata.BB.tp.de.RApedc]/D"); 

  tout->Branch("Ndata.BB.tp.e.LApedc", &Ndata_BB_tp_e_LApedc,"Ndata.BB.tp.e.LApedc/I");
  tout->Branch( "BB.tp.e.LApedc", &BB_tp_e_LApedc,"BB.tp.e.LApedc[Ndata.BB.tp.e.LApedc]/D");
  tout->Branch("Ndata.BB.tp.e.RApedc", &Ndata_BB_tp_e_RApedc,"Ndata.BB.tp.e.RApedc/I");
  tout->Branch( "BB.tp.e.RApedc", &BB_tp_e_RApedc, "BB.tp.e.RApedc[Ndata.BB.tp.e.RApedc]/D"); 


  tout->Branch("Ndata.BB.tp.e.LE", &Ndata_BB_tp_e_LE,"Ndata.BB.tp.e.LE/I");  
  tout->Branch("BB.tp.e.LE",&BB_tp_e_LE, "BB.tp.e.LE[Ndata.BB.tp.e.LE]/D");
  tout->Branch("Ndata.BB.tp.e.RE", &Ndata_BB_tp_e_RE,"Ndata.BB.tp.e.RE/I");
  tout->Branch( "BB.tp.e.RE", &BB_tp_e_RE,"BB.tp.e.RE[Ndata.BB.tp.e.RE]/D");

  tout->Branch("Ndata.BB.tp.de.LE", &Ndata_BB_tp_de_LE,"Ndata.BB.tp.de.LE/I");  
  tout->Branch("BB.tp.de.LE",&BB_tp_de_LE, "BB.tp.de.LE[Ndata.BB.tp.de.LE]/D");
  tout->Branch("Ndata.BB.tp.de.RE", &Ndata_BB_tp_de_RE,"Ndata.BB.tp.de.RE/I");
  tout->Branch( "BB.tp.de.RE", &BB_tp_de_RE,"BB.tp.de.RE[Ndata.BB.tp.de.RE]/D");


  TH1F *hDLt3 = new TH1F("hDLt3","hDLt3", 300, 700.0, 1000.0);

  int num = t1->GetEntries();
  cout<<"Number of entries : "<<num<<endl;
  double number = MAXnum;
  if (MAXnum<0) number = num;


  for (int i = 0; i<number; i++)
  {
    t1->GetEntry(i);
    if ((i%1000==0) && i>0) cout<<i<<"  equals to: "<<i/number*100.0<<"%"<<endl; 
   
    if ( fabs(L_gold_dp)>0.045  )  continue;
    if ( fabs(L_gold_th)>0.06  )  continue;    
    if ( fabs(L_gold_ph)>0.03  )  continue;
    if ( ((int)DL_evtypebits&32)!=32) continue;  
    if ( fabs(ReactPt_L_z)>0.30 )  continue; // general cut


    // we select only those events that have only one track
    if (((int)BB_tr_n)!= 1) continue;
    
    // there is no event, that has consistant hit in trigger plane and track in MWDC
    int goldenTrackIndex = (int)BB_gold_index; 
    int scintPlaneHitIndex = (int)BB_tp_trHitIndex[goldenTrackIndex]; 
    if (scintPlaneHitIndex <0 ) continue;  

    if (Ndata_DL_t3 > 0.0) hDLt3->Fill(DL_t3[0]);


    tout->Fill();

  }



  TCanvas* c1 = new TCanvas("c1","c1",1170,660);
  c1->Divide(1,1,0.001,0.001);
  c1->cd(1);
  gPad->SetGrid();
  hDLt3->Draw();

  filename.Form("figure_GoodEventProducer_%d.png", runnumber);
  c1->Print(filename.Data());


  fout->Write();
  t1->Delete();

}

