function opticsThSVD()
  disp('Hello');
  
  DistanceToCollimator = 1.26703; 
  
  global data;
  
  loadData();
  disp('Data length:');
  disp(length(data));  
  
  Num=length(data); % number of datapoints
  M = 30; % number of parameters
  mm = 30; % considered matrix elements
 
  chi2vec=[];
  
  %for mm = 1:M
  for mm = 20:20
     
    AMat=[];
    bVec=[];
    for i=1:Num;
     
      x=data(i,1);
      y=data(i,2);
      th=data(i,3); 
      ph=data(i,4);
      tgy=data(i,5);
      rbx = data(i,6);
      rbz = data(i,7);
      xC = data(i,8);
      rC = 0.00952;
    

      AMat= [AMat;[ 1, ph, ph^2, th, ph*th, ph^2*th, th^2, ph*th^2, x, ...
             ph*x, th*x, th^2*x, x^2, ph*x^2, th*x^2, th^2*x^2, x^3, ...
             th*x^3, x^4, y, ph*y, ph^2*y, th*y, ph*th*y, th^2*y, ...
             x*y, x^2*y, y^2, ph*y^2, th*y^2 ]];
        
      bVec = [bVec; atan2((xC - rbx),(DistanceToCollimator - rbz))];   

    
    end
  
    aVec = zeros(M,1);
    sigmaSq = zeros(M,1);
  
    [U,S,V] = svd(AMat);
    for k = 1:mm
      aVec = aVec + transpose(U(:,k))*bVec/S(k,k)*V(:,k);
    end    
   
    ExportParameters(aVec);

 
  
  
    disp('Chi2');
    chi2=transpose(AMat*aVec - bVec)*(AMat*aVec - bVec);
    disp([mm,chi2]);
    chi2vec = [chi2vec; chi2];
  
    Cov = zeros(M,M);
    for j=1:M
      for k =1:M
        elementCov = 0;
        for i = 1:mm
          elementCov = elementCov + V(k,i)*V(j,i)/S(i,i)/S(i,i);
        end
        Cov(j,k) = elementCov;
      end
    end
    
    sigmaVec = zeros(M,1);
    SingularValues = zeros(M,1);
    for j = 1:M
        sigmaVec(j) = sqrt(Cov(j,j));
        SingularValues(j) = S(j,j);
    end
    
    
    disp([aVec, sigmaVec, sigmaVec./abs(aVec)]);
    
    Corr = zeros(M,M);
    for j=1:M
      for k =1:M
        Corr(j,k) = Cov(j,k)/sqrt(Cov(j,j)*Cov(k,k));
      end
    end
    
    dlmwrite('TgThSVDCorr.dat',Corr, ' ');
    
  end
  
  disp('Chi2 vector');
  disp(chi2vec);
  plot(chi2vec,'');
  disp('SingularValues:');
  disp(SingularValues);
  
  CalculateLimits(aVec);
  
  disp('The End!');
  
  
end



function loadData()

  num = 700;

  global dataL0;
  global dataLm1;
  global dataLm2;
  global dataLm3;
  global dataLm4;
  global dataLm5;
  global dataLm6;
  global dataLp1;
  global dataLp2;
  global dataLp3;
  global dataLp4;
  global dataLp5;
  global dataLp6;
  
  global data;
  
 
  dataL0a = load('OutFile_ThL0.dat');
  dataLm1a = load('OutFile_ThLm1.dat');
  dataLm2a = load('OutFile_ThLm2.dat');
  dataLm3a = load('OutFile_ThLm3.dat');
  dataLm4a = load('OutFile_ThLm4.dat');
  dataLm5a = load('OutFile_ThLm5.dat');
  dataLm6a = load('OutFile_ThLm6.dat');
  dataLp1a = load('OutFile_ThLp1.dat');
  dataLp2a = load('OutFile_ThLp2.dat');
  dataLp3a = load('OutFile_ThLp3.dat');
  dataLp4a = load('OutFile_ThLp4.dat');
  dataLp5a = load('OutFile_ThLp5.dat');
  dataLp6a = load('OutFile_ThLp6.dat');
  
  dataL0b=[dataL0a, 0.0*0.049225*ones(length(dataL0a),1)];
  dataLm1b=[dataLm1a, 1.0*0.049225*ones(length(dataLm1a),1)];
  dataLm2b=[dataLm2a, 2.0*0.049225*ones(length(dataLm2a),1)];
  dataLm3b=[dataLm3a, 3.0*0.049225*ones(length(dataLm3a),1)];
  dataLm4b=[dataLm4a, 4.0*0.049225*ones(length(dataLm4a),1)];
  dataLm5b=[dataLm5a, 5.0*0.049225*ones(length(dataLm5a),1)];
  dataLm6b=[dataLm6a, 6.0*0.049225*ones(length(dataLm6a),1)];
  dataLp1b=[dataLp1a, -1.0*0.049225*ones(length(dataLp1a),1)];  
  dataLp2b=[dataLp2a, -2.0*0.049225*ones(length(dataLp2a),1)];
  dataLp3b=[dataLp3a, -3.0*0.049225*ones(length(dataLp3a),1)];
  dataLp4b=[dataLp4a, -4.0*0.049225*ones(length(dataLp4a),1)];
  dataLp5b=[dataLp5a, -5.0*0.049225*ones(length(dataLp5a),1)];
  dataLp6b=[dataLp6a, -6.0*0.049225*ones(length(dataLp6a),1)];
  
  
  
  [ length(dataL0b), length(dataLm1b), length(dataLm2b), length(dataLm3b), ...
    length(dataLm4b), length(dataLm5b), length(dataLm6b), length(dataLp1b), ...
    length(dataLp2b), length(dataLp3b), length(dataLp4b), length(dataLp5b), ...
    length(dataLp6b) ]
 
  
  dataL0 = dataL0b(1:num, :);
  dataLm1 = dataLm1b(1:num, :);
  dataLm2 = dataLm2b(1:num, :);
  dataLm3 = dataLm3b(1:num, :);
  dataLm4 = dataLm4b(1:num, :);
  dataLm5 = dataLm5b(1:num, :);
  dataLm6 = dataLm6b(:, :);
  dataLp1 = dataLp1b(1:num, :);
  dataLp2 = dataLp2b(1:num, :);
  dataLp3 = dataLp3b(1:num, :);
  dataLp4 = dataLp4b(1:num, :);
  dataLp5 = dataLp5b(:, :);
  dataLp6 = dataLp6b(:, :);
  
  data = [dataL0; dataLm1; dataLm2; dataLm3; dataLm4; dataLm5; dataLm6; ...
          dataLp1;  dataLp2; dataLp3;  dataLp4;  dataLp5;  dataLp6];
  disp('Ndata is:');
  disp(length(data))
  
  

end


function ExportParameters(params)


  b0000 = params(1);
  b0001 = params(2);
  b0002 = params(3);
  b0100 = params(4);
  b0101 = params(5);
  b0102 = params(6);
  b0200 = params(7);
  b0201 = params(8);
  b1000 = params(9);
  b1001 = params(10);
  b1100 = params(11);
  b1200 = params(12);
  b2000 = params(13);
  b2001 = params(14);
  b2100 = params(15);
  b2200 = params(16);
  b3000 = params(17);
  b3100 = params(18);
  b4000 = params(19);
  b0010 = params(20);
  b0011 = params(21);
  b0012 = params(22);
  b0110 = params(23);
  b0111 = params(24);
  b0210 = params(25);
  b1010 = params(26);
  b2010 = params(27);
  b0020 = params(28);
  b0021 = params(29);
  b0120 = params(30);
  
  
  
  
  matrix= [
   [000, b0000, b1000, b2000, b3000, b4000 ];
   [100, b0100, b1100, b2100, b3100, 0.000 ];   
   [200, b0200, b1200, b2200, 0.000, 0.000 ];   
   [010, b0010, b1010, b2010, 0.000, 0.000 ];   
   [020, b0020, 0.000, 0.000, 0.000, 0.000 ];   
   [001, b0001, b1001, b2001, 0.000, 0.000 ];   
   [002, b0002, 0.000, 0.000, 0.000, 0.000 ];   
   [011, b0011, 0.000, 0.000, 0.000, 0.000 ];   
   [021, b0021, 0.000, 0.000, 0.000, 0.000 ];   
   [012, b0012, 0.000, 0.000, 0.000, 0.000 ];   
   [101, b0101, 0.000, 0.000, 0.000, 0.000 ];   
   [201, b0201, 0.000, 0.000, 0.000, 0.000 ];   
   [102, b0102, 0.000, 0.000, 0.000, 0.000 ];  
   [110, b0110, 0.000, 0.000, 0.000, 0.000 ];   
   [210, b0210, 0.000, 0.000, 0.000, 0.000 ];   
   [120, b0120, 0.000, 0.000, 0.000, 0.000 ];   
   [111, b0111, 0.000, 0.000, 0.000, 0.000 ];]
 

 
  dlmwrite('ParameterResultsThMatlabMatrixSVD.dat',matrix, ' ');
  
  
  
  
  out = [ b0000, b0001, b0002, b0010, b0011, b0012, b0020, b0021, b0100, ...
          b0101, b0102, b0110, b0111, b0120, b0200, b0201, b0210, b1000, ...
          b1001, b1010, b1100, b1200, b2000, b2001, b2010, b2100, b2200, ...
          b3000, b3100, b4000];
      
  dlmwrite('ParameterResultsThMatlabSVD.dat',out, ' ');
  
end


function CalculateLimits(params)
    x = 0.71; % maximum valie of FPx
    y = 0.18;
    th = 0.4;
    ph = 0.4
    fun = transpose([ 1, ph, ph^2, th, ph*th, ph^2*th, th^2, ph*th^2, x, ...
             ph*x, th*x, th^2*x, x^2, ph*x^2, th*x^2, th^2*x^2, x^3, ...
             th*x^3, x^4, y, ph*y, ph^2*y, th*y, ph*th*y, th^2*y, ...
             x*y, x^2*y, y^2, ph*y^2, th*y^2 ]);
         
   val = params.*fun;
   disp('Limits:');
   disp(val);
   dlmwrite('TgThSVDLimits.dat',val, ' ');
end





