function opticsTgYSVD()
  disp('Hello');
  
  loadData();
  
  %avec = [ b0000; b0001; b0003; b0102; b0200; b0201; b1000; b1001; b1200; b2000; ...
  %         b2200; b3000; b0010; b0011; b0012; b0110; b0111; b0210; b1010; b1011; ...
  %         b0020; b0021; b0120; b1020; b0030] ;


  global data;
  
  disp('Data length:');
  disp(length(data));  
  
  Num=length(data); % number of datapoints
  M = 25; % number of parameters
  MM = 25; % number of considered singular values;
  
  Chi2Vec = zeros(MM,1);
  for mm=MM:MM
  
    AMat=[];
    bVec=[];
    for i=1:Num;
     
      x=data(i,1);
      y=data(i,2);
      th=data(i,3); 
      ph=data(i,4);
      TgYC=data(i,5);
  
      AMat= [AMat;[ 1, ph, ph^3, ph^2*th, th^2, ph*th^2, x, ph*x, th^2*x, x^2, ...
            th^2*x^2, x^3, y, ph*y, ph^2*y, th*y, ph*th*y, th^2*y, x*y, ph*x*y, ...
            y^2, ph*y^2, th*y^2, x*y^2, y^3]];
     
     
      bVec = [bVec; TgYC];   

    
    end
  
    aVec = zeros(M,1);
    sigmaSq = zeros(M,1);
  
    [U,S,V] = svd(AMat);
    for k = 1:mm
      aVec = aVec + transpose(U(:,k))*bVec/S(k,k)*V(:,k);
    end    
 
    ExportParameters(aVec);
    
  
    disp('Chi2');
    chi2=transpose(AMat*aVec - bVec)*(AMat*aVec - bVec);
    disp([mm,chi2]);
    Chi2Vec(mm) = chi2;
  
    Cov = zeros(M,M);
    for j=1:M
      for k =1:M
          elementCov = 0;
          for i = 1:mm
              elementCov = elementCov + V(k,i)*V(j,i)/S(i,i)/S(i,i);
          end
          Cov(j,k) = elementCov;
      end
    end
    
    sigmaVec = zeros(M,1);
    for j = 1:M
        sigmaVec(j) = sqrt(Cov(j,j));
    end
    
    
    disp([aVec, sigmaVec, sigmaVec./abs(aVec)]);
    
    
    Corr = zeros(M,M);
    for j=1:M
      for k =1:M
          Corr(j,k) = Cov(j,k)/sqrt(Cov(j,j)*Cov(k,k));
      end
    end
    
    dlmwrite('SVDCorr.dat',Corr, ' ');
    
    %disp(Cov);
  
    intervals = -0.4:0.001:0.4;
    subplot(2,1,1); 
    hist(data(:,5),intervals);
    subplot(2,1,2);
    hist(TargetY2Plot(aVec, data), intervals);

    
  end
  
  disp('Chi2Vec:');
  disp(Chi2Vec);
  
  
  CalculateLimits(aVec);
  
  disp('The End!');
end






function loadData()

  num = 1000; %2000

  
  global data0;
  global data1;
  global data2;
  global data3;
  global data4;
  global data5;
  global data6;
  global data7;
  global data;

  data0a = load('OutFileTargetY0.dat');
  data1a = load('OutFileTargetY1.dat');
  data2a = load('OutFileTargetY2.dat');
  data3a = load('OutFileTargetY3.dat');
  data4a = load('OutFileTargetY4.dat');
  data5a = load('OutFileTargetY5.dat');
  data6a = load('OutFileTargetY6.dat');
  data7a = load('OutFileTargetY7.dat');
  
  %data0 = data0a(:, :);
  %data1 = data1a(1:num, :);
  %data2 = data2a(1:num, :);
  %data3 = data3a(1:num, :);
  %data4 = data4a(1:num, :);
  %data5 = data5a(1:num, :);
  %data6 = data6a(1:num, :);
  %data7 = data7a(:, :);
  
  data0 = data0a(:, :);
  data1 = data1a(:, :);
  data2 = data2a(1:num, :);
  data3 = data3a(1:num, :);
  data4 = data4a(1:num, :);
  data5 = data5a(1:num, :);
  data6 = data6a(:, :);
  data7 = data7a(:, :);
  
  data = [data0; data1; data2; data3; data4; data5; data6  ];
  %data = [data0; data1];  
   

end

function res=TargetY2Plot(params, data)

  b0000 = params(1); 
  b0001 = params(2); 
  b0003 = params(3); 
  b0102 = params(4); 
  b0200 = params(5); 
  b0201 = params(6); 
  b1000 = params(7); 
  b1001 = params(8); 
  b1200 = params(9); 
  b2000 = params(10);
  b2200 = params(11); 
  b3000 = params(12); 
  b0010 = params(13); 
  b0011 = params(14); 
  b0012 = params(15); 
  b0110 = params(16); 
  b0111 = params(17); 
  b0210 = params(18); 
  b1010 = params(19); 
  b1011 = params(20); 
  b0020 = params(21); 
  b0021 = params(22); 
  b0120 = params(23); 
  b1020 = params(24); 
  b0030 = params(25);
  
  disp('BUREK!');
  disp([b0010,b0001]);
  
  
  datas = [ ];
 
  for i=1:length(data)
     
    x=data(i,1);
    y=data(i,2);
    th=data(i,3); 
    ph=data(i,4);
    TgYC=data(i,5);
    rC=data(i,6);
    TgYReal=data(i,7);
    
    %TgY = b0000 + b0001*ph + b0010*y;
    TgY = b0000 + b0001*ph + b0003*ph^3 + b0102*ph^2*th + b0200*th^2 + ... 
          b0201*ph*th^2 + b1000*x + b1001*ph*x + b1200*th^2*x + b2000*x^2 + ...
          b2200*th^2*x^2 + b3000*x^3 + b0010*y + b0011*ph*y + b0012*ph^2*y + ...
          b0110*th*y + b0111*ph*th*y + b0210*th^2*y + b1010*x*y + b1011*ph*x*y + ...
          b0020*y^2 + b0021*ph*y^2 + b0120*th*y^2 + b1020*x*y^2 + b0030*y^3 ; 

   datas = [datas ; TgY];
    
  end

  res = datas;
  
end


function ExportParameters(params)


  b0000 = params(1); 
  b0001 = params(2); 
  b0003 = params(3); 
  b0102 = params(4); 
  b0200 = params(5); 
  b0201 = params(6); 
  b1000 = params(7); 
  b1001 = params(8); 
  b1200 = params(9); 
  b2000 = params(10);
  b2200 = params(11); 
  b3000 = params(12); 
  b0010 = params(13); 
  b0011 = params(14); 
  b0012 = params(15); 
  b0110 = params(16); 
  b0111 = params(17); 
  b0210 = params(18); 
  b1010 = params(19); 
  b1011 = params(20); 
  b0020 = params(21); 
  b0021 = params(22); 
  b0120 = params(23); 
  b1020 = params(24); 
  b0030 = params(25);
  
  
  
  
  matrix= [
   [000, b0000, b1000, b2000, b3000, 0.000 ];
   [200, b0200, b1200, b2200, 0.000, 0.000 ];  
   [010, b0010, b1010, 0.000, 0.000, 0.000 ];   
   [020, b0020, b1020, 0.000, 0.000, 0.000 ];   
   [030, b0030, 0.000, 0.000, 0.000, 0.000 ];   
   [001, b0001, b1001, 0.000, 0.000, 0.000 ];  
   [003, b0003, 0.000, 0.000, 0.000, 0.000 ];   
   [011, b0011, b1011, 0.000, 0.000, 0.000 ];   
   [021, b0021, 0.000, 0.000, 0.000, 0.000 ];   
   [012, b0012, 0.000, 0.000, 0.000, 0.000 ];   
   [201, b0201, 0.000, 0.000, 0.000, 0.000 ];   
   [102, b0102, 0.000, 0.000, 0.000, 0.000 ];   
   [110, b0110, 0.000, 0.000, 0.000, 0.000 ];   
   [210, b0210, 0.000, 0.000, 0.000, 0.000 ];   
   [120, b0120, 0.000, 0.000, 0.000, 0.000 ];    
   [111, b0111, 0.000, 0.000, 0.000, 0.000 ];   
   ]
 
  dlmwrite('ParameterResultsTgYMatlabMatrixSVD.dat',matrix, ' ');
  
  
  out = [ b0000; b0001; b0003; b0010; b0011; b0012; b0020; b0021; ... 
          b0030; b0102; b0110; b0111; b0120; b0200; b0201; b0210; ...
          b1000; b1001; b1010; b1011; b1020; b1200; b2000; b2200; b3000 ];
      
  dlmwrite('ParameterResultsTgYMatlabSVD.dat',out, ' ');
  
end

function CalculateLimits(params)
    x = 0.71; % maximum valie of FPx
    y = 0.18;
    th = 0.3;
    ph = 0.15;
    fun = transpose([ 1, ph, ph^3, ph^2*th, th^2, ph*th^2, x, ph*x, th^2*x, x^2, ...
            th^2*x^2, x^3, y, ph*y, ph^2*y, th*y, ph*th*y, th^2*y, x*y, ph*x*y, ...
            y^2, ph*y^2, th*y^2, x*y^2, y^3]);
         
   val = params.*fun;
   disp('Limits:');
   disp(val);
   dlmwrite('TgThSVDLimits.dat',val, ' ');
end


