(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      8682,        249]
NotebookOptionsPosition[      7921,        217]
NotebookOutlinePosition[      8256,        232]
CellTagsIndexPosition[      8213,        229]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"tocke", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"428.8", ",", " ", "848"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"550.4", ",", " ", "700"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"742.4", ",", " ", "600"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"1094.0", ",", " ", "500"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"1491.0", ",", " ", "440"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"2000", ",", " ", "400"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.497605192186182*^9, 3.497605256823608*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"428.8`", ",", "848"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"550.4`", ",", "700"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"742.4`", ",", "600"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1094.`", ",", "500"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1491.`", ",", "440"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2000", ",", "400"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.497605258053229*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s1", "=", 
  RowBox[{"ListPlot", "[", "tocke", "]"}]}]], "Input",
 CellChangeTimes->{{3.497605269061842*^9, 3.497605273603752*^9}, {
  3.497605411137043*^9, 3.497605411605448*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{428.8, 848.}, {550.4, 700.}, {742.4, 600.}, {1094., 500.}, {
     1491., 440.}, {2000., 400.}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{400., 400.},
  PlotRange->{{428.8, 2000.}, {400., 848.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.497605274246427*^9, 3.497605412027523*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pars", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"tocke", ",", " ", 
    RowBox[{"400", "+", " ", 
     RowBox[{"b", "*", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        FractionBox[
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"x", "-", "428"}], ")"}]}], "k"], ")"}]}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c", ",", "k"}], "}"}], ",", "x"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.49760527978092*^9, 3.497605404782613*^9}, {
  3.497605591853976*^9, 3.497605672113677*^9}, {3.497605703821143*^9, 
  3.497605807254367*^9}, {3.497605841128548*^9, 3.497605848606121*^9}, {
  3.497605885539918*^9, 3.497605886643934*^9}, {3.497607614467455*^9, 
  3.497607629385591*^9}, {3.497607660196267*^9, 3.497607687089979*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "\[Rule]", "1.`"}], ",", 
   RowBox[{"b", "\[Rule]", "434.8742930592473`"}], ",", 
   RowBox[{"c", "\[Rule]", "1.`"}], ",", 
   RowBox[{"k", "\[Rule]", "408.63593678862844`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.497605329087724*^9, 3.497605405231749*^9}, 
   3.497605608984722*^9, {3.497605650331883*^9, 3.497605672738652*^9}, {
   3.497605706435786*^9, 3.497605715024237*^9}, {3.497605769397253*^9, 
   3.497605777083657*^9}, 3.497605808065692*^9, {3.497605849142076*^9, 
   3.497605891299103*^9}, {3.497607615495479*^9, 3.497607629921015*^9}, {
   3.497607661908308*^9, 3.497607687587087*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"s1", ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"400", "+", " ", 
        RowBox[{"b", "*", 
         RowBox[{"E", "^", 
          RowBox[{"(", 
           FractionBox[
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{"x", "-", "428."}], ")"}]}], "k"], ")"}]}]}]}], ")"}], "/.",
       "pars"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "400", ",", "2000"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.497605407994269*^9, 3.497605431174618*^9}, {
   3.497605476904415*^9, 3.497605507476607*^9}, 3.497605617140227*^9, {
   3.49760566154194*^9, 3.497605691392889*^9}, 3.497605722196115*^9, 
   3.497605818088165*^9, {3.497605900984082*^9, 3.497606021594444*^9}, {
   3.497606072731158*^9, 3.497606126721403*^9}, {3.497607470177102*^9, 
   3.497607570795291*^9}, {3.497607647517084*^9, 3.49760769292887*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0.67, 0.6, 0.6], 
     PointBox[{{428.8, 848.}, {550.4, 700.}, {742.4, 600.}, {1094., 500.}, {
      1491., 440.}, {2000., 400.}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVyXk41HkAx/FRlI2W1aEkoS2LkujamsnHSqbIg1XptrqklErHb4wxzDDM
mGEcoZjZJdYqR0bzpJVWT2szjiklV8pRNkxPk1Y2k3a//fF5Ps/reduEnAo4
PIVGo/mSfXkmg2FLo1EIzhrr+X2mCD+ovBZ0TaegV3xmhcdXItB3BsyuMqHg
+lze26gvwsrTR6eFLqLw8NfdwX06ISwKpcPqjRTCQxMbLIeFGDEerJRHU2i9
P/jySb0QkmcSDzcdBecgaqdXrBBtUb2HOB9YuMr3CrSaSEIkb9sUd/NoFBsY
GfoOJuLRwW+0Q7NioH7noLv5rwBdIo6HD4+LV0M2amMbAQK37qr5UxqL3fs0
2glmApafO7DPRRKH1uZS2lNJPFL4Ksc6OQ9f71avuvGEj6rohpaA63zcO54k
Zy/jY93A+5z2ongEhwWYS6/w4Lmcl8ZRJuCpvROdNYOHGwMMxbwqAeh/hCFa
HIcXvOTim9cTYb72xDoDyzhkGaIx8nYSNmYqx5klsSj7aDXXTikEM9k42YcZ
C191iERXL0JHUfBUz0EuKiTru1tbk1HC/OvDNTEXp28z/PKaxBAfbFm7w52L
GlXhaFK3BIss396qG4rBEa/v7xzrSMGuDHqEwZEYbHuS3bX6XCp8gt8kBPRz
8ODjc9zSpaJDJND8eJyDs23rN6yipHDYHN7Wos9ByOItPu56aZhRwTzgIotG
rF34Oy9uGsZOjpY0exJbd9MefkqDi2VaTuoYG/Ui3dIhXjqEe5oN7QvZWF+6
sk+nl4G6oAazlwfYeA+LSrkwA85rKpbkWrAhbvB5c980E6/vju6gPYvCTsPM
mgFxJvz0apxMiqJwuDolP33OJexxpARGEVEosP7ZkpFxCd6SwrM89yjcY0/Q
Qk2z4J2lS95kHoWl3tM/Lc7KQqJrefCwhoVqtb2oc3Y2bHb8Fhn+gAVp/Wdn
67xs1DBGmoYLWMg+OxQWbJkD9fPbP13gsxA7x8rENicHFyKU3JGjLJTZG6gi
rS8jUMoUBXizYPSP3vw62WXsXTaRXu7CwnXnGxyZ3RWU1y7xnmnBglNIie9k
6RX0Uvnjqqks9G6prtzumAvu3nFenpZCewFruZsiFwxJS2dYD4VJhT/d1iUP
Zi2fFvQ1UdCvPnMzoSwPys93lT13KPg5b/Zkr5bB7fwrxaMyCk37Vhw7rpBh
f0rzwu5fKCRPqgpGNsjRfrU/dCCDQlDG/DEdcSTjoKaPeIlj6GZjuhzn8v8+
1UtcG2QwtIw47pHufA+xVuHmdJJYcc8/vp04MKzqlpZ49LUiv5F4YXte8xhD
jkmaf6+CeDhcYzVtoxzsWd6HKomV+hsi5hI7vGO+riD2c+kwW0v8ZqaftpQ4
TmwWdJF4slFEKyYe9BD0TxCr/Kttcokru9pcjdzkKDfTFl4mjjn9bfwC4u9k
Dg45xPPkdXb0L332NZdLxFsndCeiiafEdHqkEs+Vbq0VE19Md3ogIR6wyzGR
EbueEfiIidnb11TWEgdJNm0XEjM1/Klq4tLG4s5E4jm8x4EviG0fm+4XEPfP
ty16+6VfZffHE5dVRIz/R+wJzRE+8f9f/FJI
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{400., 400.},
  PlotRange->{{428.8, 2000.}, {400., 848.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.497605431982077*^9, {3.497605462711247*^9, 3.497605508783355*^9}, 
   3.497605619058516*^9, 3.497605692430719*^9, 3.497605723175999*^9, 
   3.497605818953977*^9, 3.49760589296338*^9, {3.497605950323196*^9, 
   3.497606021873406*^9}, {3.497606074117763*^9, 3.497606127328501*^9}, {
   3.497607462995324*^9, 3.497607530576866*^9}, {3.497607565378973*^9, 
   3.497607571459769*^9}, {3.497607652857573*^9, 3.497607694328862*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"a", "*", 
     SuperscriptBox["E", 
      RowBox[{
       RowBox[{"-", "k"}], "*", "0"}]]}], "+", "b"}], ")"}], "/.", 
  "pars"}]], "Input",
 CellChangeTimes->{{3.497605523716418*^9, 3.497605559525888*^9}}],

Cell[BoxData["582.3346874636862`"], "Output",
 CellChangeTimes->{{3.497605539530469*^9, 3.497605560311019*^9}}]
}, Open  ]]
},
WindowSize->{640, 750},
WindowMargins->{{150, Automatic}, {Automatic, 52}},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 604, 16, 46, "Input"],
Cell[1197, 41, 489, 15, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1723, 61, 204, 4, 28, "Input"],
Cell[1930, 67, 487, 13, 236, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2454, 85, 797, 19, 47, "Input"],
Cell[3254, 106, 658, 12, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3949, 123, 954, 24, 47, "Input"],
Cell[4906, 149, 2577, 48, 236, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7520, 202, 271, 9, 34, "Input"],
Cell[7794, 213, 111, 1, 28, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

