(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     12416,        366]
NotebookOptionsPosition[     11284,        321]
NotebookOutlinePosition[     11617,        336]
CellTagsIndexPosition[     11574,        333]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Points", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.003"}], ",", " ", "0.015"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"0.018", ",", " ", "0.03953"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.0335", ",", " ", "0.05"}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"0.083", ",", " ", "0.08816"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.500715367754161*^9, 3.500715402924125*^9}, {
  3.500715435069948*^9, 3.50071555807851*^9}, {3.500716525142968*^9, 
  3.500716568502946*^9}, {3.500717007236354*^9, 3.500717011172595*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.003`"}], ",", "0.015`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.018`", ",", "0.03953`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0335`", ",", "0.05`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.083`", ",", "0.08816`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.500715539727746*^9, 3.500715558592176*^9}, 
   3.500716568926612*^9, 3.500717011950442*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s1", "=", 
  RowBox[{"ListPlot", "[", "Points", "]"}]}]], "Input",
 CellChangeTimes->{{3.500715543581809*^9, 3.500715551510928*^9}, {
  3.500715656580936*^9, 3.500715657030187*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{-0.003, 0.015}, {0.018, 0.03953}, {0.0335, 0.05}, {0.083, 
     0.08816}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.02},
  PlotRange->{{-0.003, 0.083}, {0.015, 0.08816}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.500715552114718*^9, 3.50071556063606*^9}, 
   3.500715657405834*^9, 3.500716571034924*^9, 3.500717014021668*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit1", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"Points", ",", " ", 
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.500715628615791*^9, 3.500715677895053*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"c", "\[Rule]", "0.8266553723247173`"}], ",", 
   RowBox[{"d", "\[Rule]", "0.02099620463482492`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.500715648774603*^9, 3.500715678499132*^9}, 
   3.50071657322968*^9, 3.500717015688933*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"s1", ",", " ", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit1"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "0.01"}], ",", " ", "0.08"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.500715659348604*^9, 3.500715693117709*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0.67, 0.6, 0.6], 
     PointBox[{{-0.003, 0.015}, {0.018, 0.03953}, {0.0335, 0.05}, {0.083, 
      0.08816}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVx3881HcAx/EjTT8dakhYlFt25BaZNrwri4q7eshKqot6oFSGirtbNXRW
XbrI7x+VH+ei/Lw7aif7ikgt0pUfSYxURj/kR7907LM/Xo/X42m++1evAE0a
jcYh/X+JOmFGr0BIZak1tDX0RbDODFq194CQGosezvhgKkKFozPv7U4h5fFV
z7I3ViI0HBp4qV4lpCZ0bmx5slqEgX9dbhtrC6ltiyKkFWEiMNuGYr0TT1CG
roNrgx+IICtZO63xagyVcEolfBh/Bjd3fVKXdEVRsfPyNKX0s6Dxvvxl1cun
dl/Pe9vBiEfib5vos8Th1ORcPXPulQQMlS71D6ACqRZu4Mb1jES8/jl907Yi
T4qz2flNUG0SrJ+a8l2OstEYYtsy3TUFblvxT+uiILy2ybNof5aKB7XMmljP
Q1g/MBmmcywdg+LXmnEnBMi5c0Sr/nMGuHZKh++Z0ZBwQrRL07JQzfex1FcJ
IfkczTZaeBGKh8eHxIGn0JlzLP5l8iWckp+sH10Xh50RavMjadl4eHDIp3ng
HDxL15s6+ORA3WYUtW4oAXrKthbdpbl4SouiPnQkIrS2PcZsLBcfU5Oe+Ocn
g8MNbNsvy4NmeIZGTVoqNO+t6FNFSeD2J1vrcXA67JvOn+OvzgffdUT3xZ5M
OGWzxlfqS8Fr9515c/MFdIeu2WbTI4WsI7R7i8UlTD3q5fpdvIyDOje4w2ey
MT6r1qT4YAG+CUq5oR+Rg+BHtkdX2hbi2i0v3aztuRBk6nV+fFWIhjrtfZe8
8+Bnbz/8QHkF4fx5LJqzBLf8+i8PCq4ipcXwS6djPtTcVkNTjyJkW09Wm7Ck
UPn++EeMYTHc8dObKoPLsBy0Tvm2rRiBo6GLW3ULwPbw476QlMCCq27w+FyA
MZg39geU4lbTfj+rnkIsXMA0OqNXhqfdqsmo9itgTAQUsHhlSJLGz3agrmJE
GjTzfXsZaunupgHKIhRUnXZrRDnO2npfeCcphklGuLcyuxwu3q7znotKwI1M
7q2fKkeQMVPsJSxFXHXHhu5AGVL/VlSJHcrAa+oTGtyWocK3ZXm5ogwct7mZ
223lcHvVteQkqxwj1WEsZbIcjMfzm2dLyrFlKivFcVyOWoM7fLa5DJLCgY66
HQoUlRZ0OafIIDOdGAqpVmCmB1/ZO0OOuHj343YmFbD4oSFjTawcXgcUr7RO
VEB03GW51yc52vUGmO/7KlBsYHfPLFIBt0VO7mMbKpF2WKPNhrg4R1ZB86iE
UHW/x4l4/mKrJXOJd4gPjPoS91kaaDCI53wlNU4l/p05rNxKHDxutI/OU6DS
QbKsipjxaHI6ja+AJXuOQYxnJfSXN9HpxHHNMUIx8eS5zAVmxKMbP41kELd6
ONo4Edd4vbgvJxbWhXnziHf41Jx+TvxM1p87TJy057B6HbsSzbryoiniif7B
/b8QK0OiK3UECuwO9O/0Jz7/ndlda2LWPs41AfGa3K3v9hLfC1kaVkS8jMaY
iCS2H77Yc53YmDumdZI4M+xrTj3xuwUJRvnEew9rMruJuyJ3WSiIm8d56YPE
ja021nXEDpFvtT8QK+y+rFARX/gYEDGNU4nshLvoJdYSdPXTif8DFC9jQw==

      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.02},
  PlotRange->{{-0.003, 0.083}, {0.015, 0.08816}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.500715693934854*^9, 3.500716574347778*^9, 
  3.500717017103358*^9}]
}, Open  ]],

Cell[BoxData[
 StyleBox[
  RowBox[{"Drugi", " ", "del"}], "Title"]], "Input",
 CellChangeTimes->{{3.50071577301786*^9, 3.500715774656848*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Points2", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.0", ",", " ", 
      RowBox[{"-", "0.01833"}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"0.02", ",", " ", 
      RowBox[{"-", "0.01667"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.035", ",", " ", 
      RowBox[{"-", "0.01429"}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"0.08", ",", " ", "0.0"}], "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.500715367754161*^9, 3.500715402924125*^9}, {
  3.500715435069948*^9, 3.50071555807851*^9}, {3.500715797886847*^9, 
  3.500715890747279*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "0.01833`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.02`", ",", 
     RowBox[{"-", "0.01667`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.035`", ",", 
     RowBox[{"-", "0.01429`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.08`", ",", "0.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.500715539727746*^9, 3.500715558592176*^9}, {
  3.500715888104785*^9, 3.500715891496984*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s2", "=", 
  RowBox[{"ListPlot", "[", "Points2", "]"}]}]], "Input",
 CellChangeTimes->{{3.500715543581809*^9, 3.500715551510928*^9}, {
  3.500715656580936*^9, 3.500715657030187*^9}, {3.500715893672625*^9, 
  3.50071589568393*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0., -0.01833}, {0.02, -0.01667}, {0.035, -0.01429}, {0.08, 
     0.}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 0.08}, {-0.01833, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.500715552114718*^9, 3.50071556063606*^9}, 
   3.500715657405834*^9, 3.500715896566527*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit2", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"Points2", ",", " ", 
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.500715628615791*^9, 3.500715677895053*^9}, {
  3.500715902244559*^9, 3.500715904537155*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"c", "\[Rule]", "0.23927567567567576`"}], ",", 
   RowBox[{"d", "\[Rule]", 
    RowBox[{"-", "0.020398054054054062`"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.500715648774603*^9, 3.500715678499132*^9}, 
   3.500715904921717*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"s2", ",", " ", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit2"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "0.01"}], ",", " ", "0.08"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.500715659348604*^9, 3.500715693117709*^9}, {
  3.500715907542794*^9, 3.500715911097859*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0.67, 0.6, 0.6], 
     PointBox[{{0., -0.01833}, {0.02, -0.01667}, {0.035, -0.01429}, {0.08, 
      0.}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVzns0lHkYB/AXJcnJlM1KRtJmm0btREqFn1ToiBz9jktp0sWlUhg2hlYj
M24xDMMbalxCkss0pq1G0yNpuiGUSyWXs7tRkkGdahft2x/P+Z7POd9zvs+K
w2FegZoEQXhQ9yPLZkQ6Q7F8yO9WHeV6k2BZGOwYEsqHKBt/xl1Mwg1b+5jx
A3zwFE+Mae4lQRU5MjzjyAdtL5Po9D0kjLxzeGg8j+q3RqQWuZLA7B4V4JxE
8Gg2qX2whQRZ7U6tR9fOgZaM82XRchLuHfw2U9vHg1MZpmlVw3lAxEzfZQxx
wW5TnCQ1LA9y4jz1dYUc6LGLL2N/z4XRutWHAiEI9sRdVAeJcmFsR76nX/Vu
gGpg0o1zwfINnetwxh3NbE71fVwlBmcfNNhlFow2KHyiVlqJoaOJ2SjYHYmc
I7d1Sxty4L1wTDM9MRb9mtLB2OCeA2xrxcb1zAREZAWFBnZlg5Lru2pxJx9V
TJUUpwdmg/x5/KgwKAUxsr4aD38RQUp98oMp13RUvhzzx3kieH5y1LdtJBN9
1PUeGFskgpluI57rqAix3vkzCvKz4A3Bgy+9OciDOHubuzILvpLi14fKcxHn
rfC05HgmaHIKNBovkGiLjOFbHicE59vuc14ez0cSm0X0CxczgLt9kvb2SCGa
lGg2vq1Kh5ieffPv7b2EiNg144XK8yDrDe/3Ni9ClXpFGvaDaXBy4R22+nwx
chLQJzerU2F5cN6dxadLUPSNkQfmtFS42exFu7i/FB31eb+KsyEFVPfnHSvC
l9H2gc9H6M7JwOEasAj7MqQ09RDIg5Mgr/3n6Ve25Wj1Din/ymkBFFvOKk1Y
FWj3a1eaRhofXNDWjw2GV9CCNevOOtckQtBU+MouWiVSsOktw8pzYM6eUbn9
W4m03fymo/oToLn1RABj4CrSvfr0VohWArzp75zl9VSh7x9c9t5awgNxRdaC
jXANmXasKB0Oi4cmfRd6oKIamYsf+hlmnoGM3/ClibIa5K/S7jVpiwUHvN3g
n7RapNMnO6VewoVgY6bQi1+HxErOvTjbaCCfyhuEG6XIe2HLq/7Y3+HGvnar
63IpIpibpd/ISHD+0PdLMus6MmIaSIaUEWDx8qe2BWXXUUhBkleJVjg0GT7m
uq+QIda1ZUnrXUOhuq6yzz5PhnSIA5+ePQqB+W5cxZBOPWpcFpOjsz8QzDep
CpwE9Yj1TFElLT0EafEOVl7fKDcFSGjYH2oMrVtMo+WIt6SwR9KK4UKURvda
ymZsvYxbLRj4nc8G7CgXV/zh1PkUg78wdGofZemmgJq5TzDoaVcYk5Tb/VYl
hqowHP9sdEw/Ro5Ykrp1WwCDxYvZuQRXjgYtmgVdUgyLrVr19SkHhNlsHa/D
MJtZuNSUsvpmhVqHcpeb7Vo7yrRdqfvtaqj9+xE4hrLjCY/1l69i+Ev2d6ma
Mq+uty+8FEMbrb76O2Wzr7uy00owKE4l/LkwlvrXscGlrBhD9hrTJ5aUpR2X
ZD0SDE6lPhMhlNunDqc4FGJYR1j8F03Z0+6FvW8BBmP2pznJlAf5O6ci8jFM
LBUZlVMmDFezy0kMfdEHzeWUs9j5BpCH4VHXWsv7lM2u6D7uzcUgt5626fyx
Px4XPynGUCx6goYos2zHrPUo/w8CfHbR
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 0.08}, {-0.01833, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.500715693934854*^9, 3.500715911605109*^9}]
}, Open  ]]
},
WindowSize->{1272, 938},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 632, 15, 28, "Input"],
Cell[1225, 40, 468, 13, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1730, 58, 205, 4, 28, "Input"],
Cell[1938, 64, 539, 14, 236, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2514, 83, 313, 8, 28, "Input"],
Cell[2830, 93, 283, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3150, 104, 394, 12, 28, "Input"],
Cell[3547, 118, 2222, 44, 236, "Output"]
}, Open  ]],
Cell[5784, 165, 142, 3, 61, "Input"],
Cell[CellGroupData[{
Cell[5951, 172, 627, 17, 28, "Input"],
Cell[6581, 191, 505, 15, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7123, 211, 254, 5, 28, "Input"],
Cell[7380, 218, 503, 14, 222, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7920, 237, 363, 9, 28, "Input"],
Cell[8286, 248, 284, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8607, 260, 443, 13, 28, "Input"],
Cell[9053, 275, 2215, 43, 222, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

