(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    124856,       2601]
NotebookOptionsPosition[    122037,       2502]
NotebookOutlinePosition[    122372,       2517]
CellTagsIndexPosition[    122329,       2514]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "1.2"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{"14.5", "*", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "0.93827"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}}],

Cell[BoxData["1.15302843362107`"], "Output",
 CellChangeTimes->{3.490065705618188*^9}],

Cell[BoxData["0.30058335153632043`"], "Output",
 CellChangeTimes->{3.490065705624257*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["#1518", "Section",
 CellChangeTimes->{{3.490065715440062*^9, 3.490065716913196*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "1.245"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{"17", "*", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "0.93827"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}}],

Cell[BoxData["1.1767712017631318`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9}],

Cell[BoxData["0.36426534003698496`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736160243*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["#3265", "Section",
 CellChangeTimes->{{3.490065715440062*^9, 3.490065716913196*^9}, {
  3.490078820853757*^9, 3.490078823686105*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "2.425"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{"12.5", "*", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "0.93827"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}, {3.490078826657857*^9, 3.490078836536103*^9}}],

Cell[BoxData["2.285011059430882`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9, 
  3.490078837562474*^9}],

Cell[BoxData["0.5313113494150453`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9, 
  3.490078837572867*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["#3151", "Section",
 CellChangeTimes->{{3.490065715440062*^9, 3.490065716913196*^9}, {
  3.490078820853757*^9, 3.490078823686105*^9}, {3.490096211641246*^9, 
  3.490096212702342*^9}, {3.490432554870133*^9, 3.490432556804729*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "2.425"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{"12.5", "*", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "1.875"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}, {3.490078826657857*^9, 3.490078836536103*^9}, {
  3.490096216469994*^9, 3.490096222060924*^9}, {3.490096635213344*^9, 
  3.49009663591096*^9}, {3.490097102246148*^9, 3.490097102837002*^9}, {
  3.49043255991807*^9, 3.490432560641929*^9}}],

Cell[BoxData["2.352867747306668`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9, 
  3.490078837562474*^9, 3.49009622364308*^9, 3.490096636775128*^9, 
  3.490097103316302*^9, 3.490432560982672*^9}],

Cell[BoxData["0.5250704804867712`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9, 
  3.490078837562474*^9, 3.49009622364308*^9, 3.490096636775128*^9, 
  3.490097103316302*^9, 3.490432561058737*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["#2413", "Section",
 CellChangeTimes->{{3.490065715440062*^9, 3.490065716913196*^9}, {
  3.490078820853757*^9, 3.490078823686105*^9}, {3.490096211641246*^9, 
  3.490096212702342*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "2.425"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{"14.5", "*", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "1.875"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}, {3.490078826657857*^9, 3.490078836536103*^9}, {
  3.490096216469994*^9, 3.490096222060924*^9}, {3.490096635213344*^9, 
  3.49009663591096*^9}, {3.490097102246148*^9, 3.490097102837002*^9}}],

Cell[BoxData["2.3290529888302607`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9, 
  3.490078837562474*^9, 3.49009622364308*^9, 3.490096636775128*^9, 
  3.490097103316302*^9}],

Cell[BoxData["0.6074595631306898`"], "Output",
 CellChangeTimes->{3.490065705618188*^9, 3.490065736150862*^9, 
  3.490078837562474*^9, 3.49009622364308*^9, 3.490096636775128*^9, 
  3.490097103326405*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "2.425"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{
    RowBox[{"14.5", "*", 
     FractionBox["\[Pi]", "180"]}], "+", "0.02"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "1.875"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}, {3.490078826657857*^9, 3.490078836536103*^9}, {
  3.490096216469994*^9, 3.490096222060924*^9}, {3.490096635213344*^9, 
  3.49009663591096*^9}, {3.490097102246148*^9, 3.490097116057919*^9}, {
  3.490099593249787*^9, 3.49009961479643*^9}}],

Cell[BoxData["2.314103084607177`"], "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, 
   3.49009622364308*^9, 3.490096636775128*^9, {3.490097103316302*^9, 
   3.490097116798388*^9}, {3.490099601130001*^9, 3.490099607748967*^9}}],

Cell[BoxData["0.6543405524394216`"], "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, 
   3.49009622364308*^9, 3.490096636775128*^9, {3.490097103316302*^9, 
   3.490097116798388*^9}, {3.490099601130001*^9, 3.490099607773717*^9}}],

Cell["0.6543405524394216", "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, 
   3.49009622364308*^9, 3.490096636775128*^9, {3.490097103316302*^9, 
   3.490097116798388*^9}, {3.490099601130001*^9, 3.490099607783247*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "2.425"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{
    RowBox[{"14.5", "*", 
     FractionBox["\[Pi]", "180"]}], "-", "0.02"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "1.875"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}, {3.490078826657857*^9, 3.490078836536103*^9}, {
  3.490096216469994*^9, 3.490096222060924*^9}, {3.490096635213344*^9, 
  3.49009663591096*^9}, {3.490097102246148*^9, 3.490097127045188*^9}}],

Cell[BoxData["2.343062918072424`"], "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, 
   3.49009622364308*^9, 3.490096636775128*^9, {3.490097103316302*^9, 
   3.49009712765641*^9}}],

Cell[BoxData["0.5603371686968627`"], "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, 
   3.49009622364308*^9, 3.490096636775128*^9, {3.490097103316302*^9, 
   3.49009712766712*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["#3608", "Section",
 CellChangeTimes->{{3.490065715440062*^9, 3.490065716913196*^9}, {
  3.490078820853757*^9, 3.490078823686105*^9}, {3.490091326299365*^9, 
  3.490091328192114*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeamEnergy", " ", "=", " ", "3.606"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HRSLScatteringAngle", " ", "=", " ", 
   RowBox[{"12.5", "*", 
    FractionBox["\[Pi]", "180"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TargetMass", " ", "=", " ", "1.875"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EnergyOfScatteredElectrons", " ", "=", " ", 
  FractionBox["BeamEnergy", 
   RowBox[{"1", " ", "+", " ", 
    RowBox[{
     FractionBox["BeamEnergy", "TargetMass"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}], 
      ")"}]}]}]]}], "\[IndentingNewLine]", 
 RowBox[{"qVector", " ", "=", " ", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"EnergyOfScatteredElectrons", "*", 
        RowBox[{"Sin", "[", "HRSLScatteringAngle", "]"}]}], ")"}], "2"], " ", 
     "+", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"BeamEnergy", " ", "-", 
        RowBox[{"EnergyOfScatteredElectrons", "*", 
         RowBox[{"Cos", "[", "HRSLScatteringAngle", "]"}]}]}], ")"}], "2"]}], 
    "  ", ")"}], 
   FractionBox["1", "2"]]}]}], "Input",
 CellChangeTimes->{{3.49006426901154*^9, 3.490064328274735*^9}, {
  3.490064485644497*^9, 3.4900644884706*^9}, {3.490064956644194*^9, 
  3.490064959101197*^9}, {3.490064993567021*^9, 3.49006500773725*^9}, {
  3.490065692029146*^9, 3.490065698163003*^9}, {3.490065729408751*^9, 
  3.490065734474683*^9}, {3.490078826657857*^9, 3.490078836536103*^9}, {
  3.4900913307707*^9, 3.490091340805666*^9}}],

Cell[BoxData["3.448778733586981`"], "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, {
   3.490091334770354*^9, 3.490091341439598*^9}}],

Cell[BoxData["0.7837718262742897`"], "Output",
 CellChangeTimes->{
  3.490065705618188*^9, 3.490065736150862*^9, 3.490078837562474*^9, {
   3.490091334770354*^9, 3.490091341449654*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"\[Kappa]", " ", "\[Equal]", " ", 
    RowBox[{
     SqrtBox[
      RowBox[{
       SuperscriptBox["p", "2"], "+", 
       SuperscriptBox["Mp", "2"]}]], "+", " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["Mm", "2"], "+", 
       SuperscriptBox["p", "2"], "+", 
       SuperscriptBox["q", "2"], "-", 
       RowBox[{"2", "A", "*", "p"}]}]]}]}], ",", "p"}], "]"}]], "Input",
 CellChangeTimes->{{3.490066901803213*^9, 3.4900670116685*^9}, {
  3.490067051792509*^9, 3.490067052016*^9}, {3.490068455008629*^9, 
  3.490068460049343*^9}, {3.490069086921469*^9, 3.490069088480128*^9}, {
  3.490078430533706*^9, 3.490078436123576*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"p", "\[Rule]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["A", "2"], "-", 
           SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"A", " ", 
          SuperscriptBox["Mm", "2"]}], "-", 
         RowBox[{"A", " ", 
          SuperscriptBox["Mp", "2"]}], "+", 
         RowBox[{"A", " ", 
          SuperscriptBox["q", "2"]}], "-", 
         RowBox[{"A", " ", 
          SuperscriptBox["\[Kappa]", "2"]}], "-", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox["Mm", "4"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["A", "2"], " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mm", "2"], " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{
             SuperscriptBox["Mp", "4"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mm", "2"], " ", 
             SuperscriptBox["q", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["q", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{
             SuperscriptBox["q", "4"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mm", "2"], " ", 
             SuperscriptBox["\[Kappa]", "4"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["\[Kappa]", "4"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["q", "2"], " ", 
             SuperscriptBox["\[Kappa]", "4"]}], "+", 
            SuperscriptBox["\[Kappa]", "6"]}], ")"}]}]}], ")"}]}]}], "}"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"p", "\[Rule]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["A", "2"], "-", 
           SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"A", " ", 
          SuperscriptBox["Mm", "2"]}], "-", 
         RowBox[{"A", " ", 
          SuperscriptBox["Mp", "2"]}], "+", 
         RowBox[{"A", " ", 
          SuperscriptBox["q", "2"]}], "-", 
         RowBox[{"A", " ", 
          SuperscriptBox["\[Kappa]", "2"]}], "+", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox["Mm", "4"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["A", "2"], " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mm", "2"], " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{
             SuperscriptBox["Mp", "4"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mm", "2"], " ", 
             SuperscriptBox["q", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["q", "2"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "+", 
            RowBox[{
             SuperscriptBox["q", "4"], " ", 
             SuperscriptBox["\[Kappa]", "2"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mm", "2"], " ", 
             SuperscriptBox["\[Kappa]", "4"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["Mp", "2"], " ", 
             SuperscriptBox["\[Kappa]", "4"]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["q", "2"], " ", 
             SuperscriptBox["\[Kappa]", "4"]}], "+", 
            SuperscriptBox["\[Kappa]", "6"]}], ")"}]}]}], ")"}]}]}], "}"}]}], 
   "}"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.490078431850433*^9, 3.49007844563452*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.490069089401318*^9, 3.490069163769785*^9, 
  3.490078443100245*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CForm", "[", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["A", "2"], "-", 
       SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"A", " ", 
      SuperscriptBox["Mm", "2"]}], "-", 
     RowBox[{"A", " ", 
      SuperscriptBox["Mp", "2"]}], "+", 
     RowBox[{"A", " ", 
      SuperscriptBox["q", "2"]}], "-", 
     RowBox[{"A", " ", 
      SuperscriptBox["\[Kappa]", "2"]}], "-", 
     RowBox[{"\[Sqrt]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["Mm", "4"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["A", "2"], " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mm", "2"], " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{
         SuperscriptBox["Mp", "4"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mm", "2"], " ", 
         SuperscriptBox["q", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["q", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{
         SuperscriptBox["q", "4"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mm", "2"], " ", 
         SuperscriptBox["\[Kappa]", "4"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["\[Kappa]", "4"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["q", "2"], " ", 
         SuperscriptBox["\[Kappa]", "4"]}], "+", 
        SuperscriptBox["\[Kappa]", "6"]}], ")"}]}]}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490068491710451*^9, 3.490068506289179*^9}, 
   3.490069170160666*^9, 3.490078454531076*^9}],

Cell["\<\
(A*Power(Mm,2) - A*Power(Mp,2) + A*Power(q,2) - A*Power(\[Kappa],2) - 
     Sqrt(Power(Mm,4)*Power(\[Kappa],2) + 4*Power(A,2)*Power(Mp,2)*Power(\
\[Kappa],2) - 
       2*Power(Mm,2)*Power(Mp,2)*Power(\[Kappa],2) + Power(Mp,4)*Power(\
\[Kappa],2) + 
       2*Power(Mm,2)*Power(q,2)*Power(\[Kappa],2) - \
2*Power(Mp,2)*Power(q,2)*Power(\[Kappa],2) + 
       Power(q,4)*Power(\[Kappa],2) - 2*Power(Mm,2)*Power(\[Kappa],4) - \
2*Power(Mp,2)*Power(\[Kappa],4) - 
       2*Power(q,2)*Power(\[Kappa],4) + Power(\[Kappa],6)))/(2.*(Power(A,2) - \
Power(\[Kappa],2)))\
\>", "Output",
 CellChangeTimes->{3.490068507500475*^9, 3.49006917174618*^9, 
  3.490078456246605*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CForm", "[", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["A", "2"], "-", 
       SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"A", " ", 
      SuperscriptBox["Mm", "2"]}], "-", 
     RowBox[{"A", " ", 
      SuperscriptBox["Mp", "2"]}], "+", 
     RowBox[{"A", " ", 
      SuperscriptBox["q", "2"]}], "-", 
     RowBox[{"A", " ", 
      SuperscriptBox["\[Kappa]", "2"]}], "+", 
     RowBox[{"\[Sqrt]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["Mm", "4"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["A", "2"], " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mm", "2"], " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{
         SuperscriptBox["Mp", "4"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mm", "2"], " ", 
         SuperscriptBox["q", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["q", "2"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "+", 
        RowBox[{
         SuperscriptBox["q", "4"], " ", 
         SuperscriptBox["\[Kappa]", "2"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mm", "2"], " ", 
         SuperscriptBox["\[Kappa]", "4"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["Mp", "2"], " ", 
         SuperscriptBox["\[Kappa]", "4"]}], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["q", "2"], " ", 
         SuperscriptBox["\[Kappa]", "4"]}], "+", 
        SuperscriptBox["\[Kappa]", "6"]}], ")"}]}]}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{3.490069250149356*^9, 3.490079462939851*^9}],

Cell["\<\
(A*Power(Mm,2) - A*Power(Mp,2) + A*Power(q,2) - A*Power(\[Kappa],2) + 
     Sqrt(Power(Mm,4)*Power(\[Kappa],2) + 4*Power(A,2)*Power(Mp,2)*Power(\
\[Kappa],2) - 
       2*Power(Mm,2)*Power(Mp,2)*Power(\[Kappa],2) + Power(Mp,4)*Power(\
\[Kappa],2) + 
       2*Power(Mm,2)*Power(q,2)*Power(\[Kappa],2) - \
2*Power(Mp,2)*Power(q,2)*Power(\[Kappa],2) + 
       Power(q,4)*Power(\[Kappa],2) - 2*Power(Mm,2)*Power(\[Kappa],4) - \
2*Power(Mp,2)*Power(\[Kappa],4) - 
       2*Power(q,2)*Power(\[Kappa],4) + Power(\[Kappa],6)))/(2.*(Power(A,2) - \
Power(\[Kappa],2)))\
\>", "Output",
 CellChangeTimes->{3.490069253272836*^9, 3.490079464510734*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.490427245129123*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M", "=", 
  RowBox[{
  "Import", "[", "\"\<ParameterResultsDeltaMatlabMatrix.dat\>\"", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.490427334990764*^9, 3.490427371228481*^9}, {
  3.490427412401813*^9, 3.490427424900011*^9}, {3.490427615792932*^9, 
  3.49042768074956*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0.054509`", ",", 
     RowBox[{"-", "0.74827`"}], ",", "0.26109`", ",", "0.67624`", ",", 
     RowBox[{"-", "0.30008`"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"100", ",", "2.5958`", ",", 
     RowBox[{"-", "1.7038`"}], ",", 
     RowBox[{"-", "0.5505`"}], ",", "3.6638`", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"200", ",", "1.1501`", ",", "0.29784`", ",", 
     RowBox[{"-", "7.8499`"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"300", ",", 
     RowBox[{"-", "4.947`"}], ",", "2.892`", ",", 
     RowBox[{"-", "0.33448`"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"400", ",", 
     RowBox[{"-", "0.46064`"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "0.17356`", ",", 
     RowBox[{"-", "0.095701`"}], ",", 
     RowBox[{"-", "0.54396`"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"20", ",", "0.010186`", ",", 
     RowBox[{"-", "2.2076`"}], ",", "0", ",", "0", ",", "0", ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"30", ",", 
     RowBox[{"-", "2.67`"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "0.113`", ",", "0.095563`", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", 
     RowBox[{"-", "0.20324`"}], ",", 
     RowBox[{"-", "1.4723`"}], ",", "0", ",", "0", ",", "0", ",", "0"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "101", ",", "1.3408`", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "102", ",", "12.215`", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "120", ",", "1.1107`", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "210", ",", "0.049407`", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "201", ",", "1.8449`", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "21", ",", "0.13673`", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"111", ",", 
     RowBox[{"-", "0.029536`"}], ",", "0.30489`", ",", "0", ",", "0", ",", 
     "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.490427357784468*^9, 3.49042737164486*^9}, {
  3.490427417274519*^9, 3.490427425371187*^9}, {3.490427618284088*^9, 
  3.49042768124372*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"M", "[", 
  RowBox[{"[", 
   RowBox[{"1", ",", " ", "2"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.490427399912104*^9, 3.49042740372552*^9}, {
  3.490427598465925*^9, 3.490427624928144*^9}, {3.490427660740024*^9, 
  3.490427675784751*^9}}],

Cell[BoxData["0.054509`"], "Output",
 CellChangeTimes->{
  3.490427404451335*^9, {3.490427598880446*^9, 3.490427632615826*^9}, {
   3.490427664121025*^9, 3.490427683048458*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"ContourPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", 
          RowBox[{"i", "+", "1"}]}], "]"}], "]"}], "*", 
       SuperscriptBox["x", 
        RowBox[{"i", "-", "1"}]]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}]}], "]"}], "+", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"M", "[", 
        RowBox[{"[", 
         RowBox[{"2", ",", 
          RowBox[{"i", "+", "1"}]}], "]"}], "]"}], "*", 
       SuperscriptBox["x", 
        RowBox[{"i", "-", "1"}]], "*", "th"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "0.8"}], ",", "0.8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"th", ",", 
     RowBox[{"-", "0.2"}], ",", "0.2"}], "}"}], ",", 
   RowBox[{"ContourLabels", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490427118677909*^9, 3.490427162148484*^9}, {
  3.490427198460581*^9, 3.490427204463345*^9}, {3.490427367703049*^9, 
  3.490427394764676*^9}, {3.490427433206765*^9, 3.490427592256238*^9}, {
  3.49042783220927*^9, 3.490427837022582*^9}, {3.490428015180399*^9, 
  3.490428016329893*^9}, {3.490428253745247*^9, 3.490428265048763*^9}}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxlXAdYT9//F1lfW0YIlZVNWSUORfYeia/9TYSQkpWt7DKSqChJqbT3OO0l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   "], {{
     {RGBColor[0.293416, 0.0574044, 0.529412], EdgeForm[None], 
      GraphicsGroupBox[{
        PolygonBox[{{12, 704, 11}, {235, 228, 14}, {423, 252, 28}, {882, 290, 
         29}, {29, 228, 30}, {239, 243, 15}, {235, 239, 228}, {243, 239, 
         235}, {247, 239, 15}, {713, 30, 45}, {1511, 1152, 9}, {1210, 1635, 
         791}, {13, 29, 28}, {1164, 1576, 45}, {882, 713, 44}, {1573, 1575, 
         714}, {713, 882, 29}, {530, 423, 290}, {228, 229, 30}, {713, 714, 
         44}, {714, 713, 45}, {239, 229, 228}, {1510, 1512, 634}, {29, 13, 
         14}, {705, 704, 27}, {423, 791, 252}, {530, 792, 423}, {1567, 1569, 
         705}, {1431, 1430, 530}, {239, 247, 229}, {30, 713, 29}, {289, 707, 
         27}, {707, 705, 27}, {704, 705, 26}, {1540, 1221, 252}, {871, 279, 
         11}, {1577, 1573, 714}, {28, 12, 13}, {704, 12, 27}, {228, 29, 14}, {
         1152, 1423, 9}, {1424, 1310, 416}, {11, 279, 10}, {1755, 1252, 
         289}, {416, 636, 10}, {872, 871, 26}, {1251, 1755, 289}, {12, 28, 
         27}, {871, 872, 279}, {704, 871, 11}, {636, 634, 10}, {252, 289, 
         27}, {1574, 1163, 44}, {1570, 1251, 289}, {1423, 1502, 9}, {1163, 
         1432, 44}, {883, 882, 44}, {29, 290, 28}, {882, 883, 290}, {1756, 
         1311, 416}, {1568, 1158, 26}, {1312, 1245, 279}, {279, 416, 10}, {
         792, 791, 423}, {1158, 1425, 26}, {1425, 1153, 26}, {1310, 1756, 
         416}, {871, 704, 26}, {28, 252, 27}, {290, 423, 28}, {1432, 1159, 
         44}},
         VertexColors->None], 
        PolygonBox[{{1153, 1699, 872, 26}, {1699, 1312, 279, 872}, {1311, 
         1219, 636, 416}, {1512, 1511, 9, 634}, {1220, 1567, 705, 707}, {1159,
          1704, 883, 44}, {1319, 1431, 530, 290}, {1704, 1319, 290, 883}, {
         1219, 1510, 634, 636}, {1245, 1424, 416, 279}, {1430, 1636, 792, 
         530}, {1635, 1540, 252, 791}, {1636, 1210, 791, 792}, {1569, 1568, 
         26, 705}, {1576, 1577, 714, 45}, {1252, 1220, 707, 289}, {1575, 1574,
          44, 714}, {1221, 1570, 289, 252}},
         VertexColors->None]}]}, 
     {RGBColor[0.3576989419903196, 0.16917507554830155`, 0.6197694514683569], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNlktsV1UQxu//9t5L0RWSPggqRaAPK6CG0BcmKMb6b+nGBy2sjPZBlbSQ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         "],
         VertexColors->None], PolygonBox[CompressedData["
1:eJwtlEtsTWEUhc859/xHMGwkmtIqvbeotkSiCAlq0oeJ11hIDETaSMxEWtqS
FNEOPBIDSqImNcCASiPqUa+J1ExLPKJEELMiEd+6y2Dl7LXX/h/78Z/K3e1b
25IoiraAFPRmUdQWouhtjA/hAnYdGILPhU+gl8NLia1iwRfsX6Af7TDYgz6M
vwb9Evwl9kp8+1k/A2wi9iu+BWjD8Fa0lsxaH77lwWfqrOv4VmNPEV8Kvwk/
gt2PbzZ8AJ5n7RLwAv6XMx+hp5nPfghqsevBK+yY+DesPQ1mwtvBHezb4Ezk
nCd1t+C9Z6F/gC/MvNdSYo7Dz6OXwK8R04z9HV81/H7sWkwH56KarMG+CCqw
b6E3Yl8BBfhd+ARrd7F/SQ7At6P9xFeH/lT5onWAcex1xNRhN4I/iXNSL/qC
76qejKDtC851kPgx9lqE7zH6EzAN34n+DL0BfgO7M/PeG+CV2BXan71G4d+U
H+jG7kpc+2OqUewenMAuEP8cuyZ2bhuDe6scT2FPAg0Zn2IuXWB9zjkpF91B
ZyunH8FrFKsz32GMp56tg2Be8J10F9VsIHXOylU9HELbFly7VYlr2QofjV3T
Efj74L0eRJ6FTnw9iWdCs7k2uFeaUfV2c3Cv1GPN4org2dRMNnH2veC3EuXc
64bgWVXPL6PPD+7t3pxnRzVTrTRDi9FPwpfFnuE8+lV87cSW4/uI9hpelron
O4JzVG7q4dHMPVUvVdOO1GfqrDnEtxA7CGoT1+As9rng2dUbldYUPLuK0dnd
qdfqDoPwQvBdDuRcqyn4ocQ1K84WvrHEM/YZ7RP4HTmmPngGNXv6h/Sk3lN7
5YmpzvyG9XY1QxXB/xj9W7RHcdYyz6Jmrgq7N/Vanana6I3qbZb9/9c0Z+6F
/jn/AFGumnA=
         "],
         VertexColors->None]}]}, 
     {RGBColor[0.45619906002436944`, 0.34044017937492965`, 0.758223283220945],
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmFuM1dUVxv/n/Pc+klqr4jw1Nk3VEqNVcGSgWFKFgaKCWG7aN2XGNgWs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         "],
         VertexColors->None], PolygonBox[CompressedData["
1:eJwtlVlsjVEUhf+/9z9XE0J5pB6METE2ak7MijYSpX01NIQKTQwlElMNUYQo
V8RQJEgoouYhIjFFvKDVmlUlHjyY3kRIfMvysHP32mufffa/zzrndptXUbw0
K4qixViC5YcoqktH0ZpUFOXFUbQRnAGXkvQd3EBSITiG/0DsNP42Yt1Zu5LY
VPA0rAXuBLGb+LXwy/CPwheBf1KzMnaNTXAniS1JuUZe2nuo9ntsN/5ZYmvh
x8PvYO1aYur5NzUuwk0hNg5/Jzn14Ax8MXw1+Dx4LPwI+CrwGXB/cG/wavAL
/Fpis/EXUfQJeC94Jng2uCC4pmppD/UyNHg26ukceE/i3taDxwTH5GvPo/hH
sF+x99ifuGf1Oo81h8DXwAdSntE68HFwGbgTuD/+Y2JN9NKIzQ2eqWZZQs31
cLuIZcPVgnvgn4Avh88F38OvU01qXUl51j2DOc1ce3UG58Tesxf+R/JzqHcy
thZ2gfMia0K1qxL3pj1qEs9Ys9XM2+M/IfaG9XXYQOq9I9aX2B/4LfxmiHWE
OxX724vBhbFnkC+tYe3wP5FTnfjMdFbq4RH+VvLbkn+X2FP8y+QsJ3cO1qr+
sZX42eRcSJwj7gA2Av8ZNVpZO0kaAR8DL8jyGb0lv2vwLNsQ2w53J1jLE1nz
B74M3AA/Bv4zfmPivaTpV+DXwdrUTG/gV2CTWFtA/lly71PzurQamasGT0g5
pxl8ST1H7knc0uC9lZOrb0m7tyOxv2UksfzY3/QUPBjcF/xOmg7uWb2+jK2l
cmKvYmuqivxN2ChypxMbFFxDa/Pp4Tn+RGKj4T4T+4b/NXjvNOsfBH+TvkVv
hM5Od0h3R2f4MviO6W6VZ1mrmxNrS5qV1noHa0GaqwzWrLS6gtjtxGeos9OZ
SlsJOWWxNdYv+A3S26M73YRfpHnhfyH2Hjws+KwHsrYFPA5cAh4MbtVdl17A
Q8FXwQcT380M6zeCN2BbIs9oeHBN1dKMC4P31F7zyRmi9yFt7Uqjs4L3UG31
NA38ATwk8UzlTw3/1xK7hXVI++7ozpbANYN/pNxjF92n4NkfZv344G/St0gD
x/m9Hqw1nfE+uJq03269adLequDZSoM9wQ//380+xOql3cRvizSuu7o9Mac7
mwJfwyZn+QykVd3Jf3cxMrcwWGvKmRCsIWlHM3+W+I3X267/iAGaZdpvm2as
by0N1qK+WW/HgGAt6g2ZEXxGOhu9GX8BUdHgTQ==
         "],
         VertexColors->None]}]}, 
     {RGBColor[0.5546991780584193, 0.5117052832015577, 0.8966771149735332], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmFuMVtUVx893ztnbF4vQCIa2GNGpyKWJLaIJbXUwNm1SHhhaJpGb39hY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         "],
         VertexColors->None], PolygonBox[CompressedData["
1:eJwllEtsV2UQxe///r+5C8FSEx8BlYSHxj7cILABkY3BBBZahY0Eao3FBtry
UlcICDGiPMLLhEILVCCBNmBNrG1aWzcKCdjgAgyWhyYEH8EENKEbF/5Oz2KS
OTNzZ+Z+c2amNbTWteRZlrUgCTkQWfYJSlcpyybh6ADvBfeBp4KPg+chveDp
4Ooiy2qRy0qCrRlfjrwMvgGuRj+EPAo+A16J3kd8WznLXgffIffz2LrRHyfm
JHgIvAT9JrZB8CPEnwWfpUTg+xZZDG7CfwnfZHAF+kVyHgFvBz8Av0NML/ox
cuzJ3NMI/oQt8F8hfj76n/ifyv1Ph9C/JmY/vla+mYP/L2xP4+8pufaa8L+p
h1F8U8CHwSl3rUG+P1F2zYHkf9K/dOPvJrYD/BN4Dvgl8N/gmbnf+Dfp2E6g
V2A7T64t4C3gYXK+hj5GzGz5sC3EfxJbNfgB0o6vH1s7sZupvxPfR9i+IDbw
f45+Clst+nfqgdi5yG1h4rclc0CzVw97kjmg2X8FnhHuUb0p52xwO/Ik+Evw
i2GOiBvflFyrLblX1VwEvgeuQR/Gtg+9E9sz4H7wD5p18qwH+YfaMEfEDXFy
B3obtidyc2Yt8RuRamKHwD34GpCtfL+AmCr0VfgfRj+Nvz+ZM+LKDfFdsy78
73XYvid+AvIesX8gm8M9qRfN4Kq4jOxCH0OO4utAbvH9CmIuk78Ic/M6NR9C
/yCcayn4Lv4F4beZkXuWdeALJc+0iVw14V15LDcXXw3vljh5lfiPw7Xv4P8V
PJ+Ye+j/IJ/i+wVZjb4WKYc5L67vzfw2P4P/LfuNagpzSNzRDivXLXLez51z
Q+Ge1aveeH+4pmpNRFrxNxee/bP4m/BfA4+hL9M/Fe5ZvYpjertj2OrLfkNx
dx24qmwOVxZ+Q72ddn594RlrtorRrrYUrqWdbUCfTo7Okmd8LbyT2kW9wWfh
Nxl/C+RNvUX4NlSSowI8qfBu6iaIW7uTd10cG8B3NHmXjpd9u44k3wbdsEbw
c2Fu6ca9hf5fMve04+L2wWSuj3Nc/x6+fdrRUfRNyb2tQd4Pc0Zc+Z2YxnAP
ql0PfkH3pzA3zpV8m+aGd1M3ahr6vvBs9Caaxbvh2Wsm18M1VatZ78X384jZ
WfIN3arvC+/CG2Xf4q7kXnSTtbuvhG+Hdli3blW4N928HboHhXdBMxbX3g5z
QZxbDZ4V7l03Q7WXF56FehjB9yMylPmG6zYuDN8G3cgPk2+abplu7uHkm6pb
qh06l3wzdSuVQ7t8sPC/aKf/B8wM6G0=
         "],
         VertexColors->None]}]}, 
     {RGBColor[0.6295346917303087, 0.633149267052294, 0.9109968141136833], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFl1tsVVUQhvc5Z+9tjJhAKGqLCkWglEuJ4oORm4lKkERQUx+A0gpREKQg
Fp+UIuGiLwUiGiWhCogRjFhp8QJCfDAUEtpSEwEVE01FowHKkwZ80f9z/saH
lTVn9qxZc/lnZp3KJaufWFVMkuSRQpKUtC/Wfk1Eq+gu7Xv1cYbo94pBPyr6
bJokT+ZJ0qffGyWzR/tc8X/T2VrRTdovab+s9aP4ByX/dZYkH4l+UfuNWmsk
M0M6Zmr9KbnuYuw14ldoX6M1WfQ0ff9Z54eLrtNdC7Q2FGJfqNUtnYeLYcsx
0XXS/aFWt23pL4Q9zVoHk5C5Td9v1doh3vvaH9AdDeKPkb7RWjPt+0j7diEJ
f/DlTvHu0JpseoTWGOmZVAg+sRonnUulc7h+365VwdL3y/KjSfz7CsEbbj3P
pvEbujoNveh8XGuVeOuS8GORbDguusN7l9Y2yc7Wt3rR80thJ/zPpedb2XFa
9FW+FyNuV5wX4nZa37u06vitvScLufWF4BGzCeItz8NPvtU5/k3SPyuNO/eL
/4HWriTywHniTJ7XOtcTJbs8jdhWloImvuudG+Sr0ogFcTiuc5nWO6KPSu5I
KeTAJ9jcqvWJeG2l0D9U58q0WsSv9W9o7IJG/pxkc+Ngingr0sg7ug+Vgg8G
atLAQXka2DlubDf5LL4vMPbafRZsvy57K7VGOBfEh3wMSqOmDhlTXcYJtuPD
LttzRrI9zg9n0T9Vsf8+jbwRd/SS3wf1+yx5LYS/+NrsXG+wzb3apxfjO/bO
d+5ekY0n85AFd8S8XPucQmANzFWVwibs6RR9ohT10q/fbxaiFrB3imMIBog/
8Sau40rBv0d3Pae7RpGnPOoN/iztVyU3nT6QRW38VxdpxB2MTxV/j9Y8yf8h
3jTRd0tmh+jdWfQi7Oow5t8Sf5/4i5LQc9g9YVUe5zl7g+g8j37WLt5XadTI
ROecet+i/dVS2AYmqWvqG9/anK+b0qDBIv1pRxY9aqB/IX+z7hmkdaAYetFP
n1yZBb7BdlFn+8TfrFVI427uvWgevnN+v+uraBn07HH/JQ7YCx/fW3yWnrBf
8seyOJtr702jBs5pPVSMuiBv6AdD4A78XfKdP5iPzFDnlzs3+V5s3mh7Thoj
5KKhEBgFn8SJc62u/VHusfNkz19p9K820S8rVvf7DFjmXvB7zhjH9sG57Xc9
EcOx4g9zj12m79VZ9F14ZaWoR+hbLLNSMlMkcxe2aF+Sx7cpuutMIeqA/jTR
PQq5Svdk+JW2/6zOLsyjTsE8tUDdgOMqx5/aqnJ9jbM+ap8eQ68Bkz2F8Jt+
X5TOxiz6HBhrd3/b6xnJWWqS2qNOmV0TPL/+lnyz6Kn2Y1ox4tjoM6tcs9+Y
pn8gu85zZLtnSWchYkEcOLfNvmwCR3nM3ZfymLXM2TH2r8b9FkyRa/RxlvvR
22I97FuNVeLEHfDBbIv51P101/4Q3XWMevPbgv5AXYPTfs/lja4faod6+sW1
Q59rS6PXDRNdlkdfAL8bXWtbfe9s99Oz7oPnS4EzMAZO52Yhwxw64nmBPf3u
t4csD5/aOl+IWLyrs1/mgWP64gBG0HHUs6PWNYn8RMmOzyNX+NFnnLTq/nuz
wF6va6LZ7x96IH2sx+8G7K+X7Lo8eOQbfqPfE3N8ti6PGXPF9i62Dbtk8xd5
4KjTNYEOekCtZRocr4G+0eSZhd5628DcafI7oclznvg8JduO5OEHPabBepaJ
fywPWw557hMfsNxrmz+Wvs484k7tgz/qfJDrBex1lILm7KlS9KYLnhfMM2LF
TL7u/FJfXe7/vJvaPReYUQ9ngZMt7quLHMtux/Oi81nvHnjKfXBhFnWC3AHR
b6chT/11Op74eM020HNPer5z/oRpfF2fhb/41OGe8LR43+WB1wq/lyd5dvxq
m6jvHudit+7/LIvYglPwTS/dbIxRL+DohOPDe/OqsU2/muQZie6Llt9sut6Y
OuMc8d4/kEb893r+MS+YRftSz6NCvKvAA+/ecQOz1jNxrvsS/YG4gZfWNHCw
wXMG22rFH5zFW3Kn9vFZvCHpqd2uB/oTOKlwvxprmvuq/OZkRow1lsosT08b
6d49xvLQ9GHqoyELn8v9RkC+zz5Qs6NND8zHS/4/QR9Y4XlR47yhkz6xNIte
wH+U1/w/Za34z+dxjpw/k0Xeu0X/k0b9MJdGek5tcT/k3umS+T39/57JtvOn
NP5f8W7p9n8vbLhuTNILqEVwA2bQzUwkl+WOG/oaJbM6j3kGPplb1OBjsvHT
PLBezn+NPN6O8HamwQdv9HPySK9alAVe6WkVfgdec22jE794A4E73oDb08BV
u2WoJ/RVeEYQsxcctz6fJSa8E99Io5bJT43z1Wb7qS/sPZKGzaPtO72XOQRu
wS//1aqN2yFZYBEcJlnkhrzwxi732wPsVBtL/wKSyt3d
         "],
         VertexColors->None], PolygonBox[CompressedData["
1:eJwtlElsT2EUxd/7/999FkgQFVNIicQUYlhIq7owxMYQYaODIbSmkhp2ggVh
Q0QJokiw0BoqMUYkQhBTW0MQlVgQYmFYWWDB7+RY3Jd77j33e+9+99xXunzD
gvWFJEmWYBl2lMe5SJJJBB+kSXIQfClPkt3FJKkhfwbcE9xCvhncC7831gbO
4c+ktg28E34FeCX4NzXl5F+Bm8F7wY3ggdiXzDH548hvx++D1YC/g7s4ax34
BO/6xZlPwP3BTeQegm9kjsl/pz7I/SE2lfpOOC/JTSM2Bf8TnOPqB1xB/hmx
FvBdOJfJnae+Ilwj7jzwU/A2Gdxqal6QKw/nPsJpo74dXEvuB5xW8D3wQvBn
8B78x9Q8KPqbO/Hz8F29KTp3XT0k5tzGLyF2peBYQ/gO1Puy1N9yH3yz6G/6
C/8qsenwl4DHkBuLdRY8017knoS/fTv5y+QOZ57lPs44gn+F2H78BmIPwdPA
P+G3Y+/B9eDB5AdS/wg8P6yN5+SryFVj38SnfnnuGnH7UbMVXAW/HVwGZxN4
Mzay+H8mcNeBh4NHgHP8wE7BPV3wLJeGZ6WZTsZvID8CfiXvW4Y/LPyukqK1
10TNnMQavJV5JpqFNDoa7io4Q8iNT/wu9axe9c79+N1yv1tn7IJ/DLwYfjXW
F/8VnA8Fz0ja2QKnMbWG7oDPZt6NS+CV6pX8IN1f0bvVnFmb2rG3+GVwvhZ8
h93xO4h14Z/FRoXPUK1m0ApuCc9Kdyotn4T/OrWmR+eekWYjDWh3Z4V3UTvc
I/c7dLZ2uBK/IvfuaeZNcA9gQzl/kPZV/YZnWyXNgWvBHal3ujQ8A929aqT9
i5l3VzugXpKwNtWT7nJn+CzdaYR3QrugHZ8b1qi0OTu11i9k3k1pfmp4B7V7
E1Jrf0X436IdkJbnhWulad1tl76n4DvuCM9Us9TOSgtj1G/RmlgLPh7W1jBw
il+PveG8GfCv4RfCu6jYIv3/wrslTWwOa0CzlyY24K/P/a3S7Br8ieGzS7GN
4Mbcu6qdqMM/GtamNKN/4Y7wv0X/xEnhM1SrnVFvA4gdSt3j6tw7pV1STzX6
H4d3TzOrC/ekXqSZfzOlxH8=
         "],
         VertexColors->None]}]}, 
     {RGBColor[0.7019550706137042, 0.7495086647331509, 0.9126477756944091], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNVktMXVUUvdx7z7G8avzWMqiD1onGSRV8LSmgNkHFVImvMX4ATYwGE4hN
0Pp9dCYQCk0bm2gsdaKJQFNaolXTj0YLiQU0wc+AxkmTNnFQR/BEmOBaWaup
g5Oz777n7L3O3mvvcza/vKf0epokSQUjw6jJk2QSitOQD1UlyXkoZxLNUxgX
IJ+CfjPWFDEPY/1ISJJG6Jcx/4NxAP9OptrD9eew7l58N2E+i3EP5Hbo/4T8
BOROzK9g3ymMIejvgs1NGIv4N4h/KxgXof8Gupmo7z0Yx2H/SKJ5AuMTyKOZ
vinPYs1W2OiCXIZ8FWMccp+xUN+D+W+MM5BL0F+BfCwRpsuWy8B1MGp/L+Qf
g+QxzOMYD2DfIrCNBvkrQB4Dhv2J5KXsOq5RYx7PtIY4OfM7g80pjPtho9t6
7ueenfBfgbyaKjbMwa5EGImbONsh/47xvuNAv4xngzEQzwwwHoKtNuz5CPov
o3zSJuO+hjUjqXLPvJ/B+s9y4awwT87J19D9FpTfE5g7MMqQe6tkm/Gmz4ox
5FXKN8/egXlnKrxNPjPPS16QK+RG0Vyh/CF8nYj65t7qXLFiTnqdiyXHar/j
Vm2ZXHktFX8ex/rHMNbMz4258r47FQfIhbJzftrc4BrKnGsssz4o0wbjQR+D
ztu0z7IBfr5nnqD7IlccGUNypQh8LcZ12Nymrs56xnkL9hQwb4duW6bY9mP9
fZCbzesBc/tJ2N4b9W/MHKOvn2Fja1Ss3oniKPctJMJ70TkddK6rM/ml/AZr
kfHKVC/03Wxcdxtbi7nG876I9fuwvj4TZs4l/G/M9U15KRXHWNfbU9Vn67Ua
c22SD33uD+TIw5k4PWAMPG8hEwbipa7P+g/gvy9qD7m1zZwfTnUO9owB/O/H
eATfs8B8SxAHLqXiLvP7K/7Nm7ejlsnbuSrhJuZF1+Eu98NNrh1irU8VF56b
5yeOCfh5O2o/ud2WaO9x/J+O4h/90DdrhbU1mau+GPOKc0R+kUOM/Qr070X5
G4X8Q1Q/YL3Tb8kxaHAtcE9t5pxBtyPX91vY91xQPoZSxemIa7nsmJCbD5qH
S7ZJ+7RTZz190WbZuWMs2s2BBseh1muob2PPiLJbQ/9R9cB7hncHexBzzDpj
jtibWas9jvGc+fcV9n2cKzbsE81BvYJ1esl3WQn63RjrzB1yqODzdpp74+77
x9wDWRcL5g/XXftPmfHhPOx4HbA87nut0zF8AVjejcJKn+vtdxlr/03Fg6K/
KT+NtTcHxZ682BfEDXKs6J5/NBU+YmN9z7kf0t6K7XS5llibXUG9gGueDco3
c/0o5JNRPbfVaxnPVWNjvZ9zj2Y9NhsnZXLtzSC+rcPcExQH9ske36fMc7f5
8Gkq3AuO7VHfMezT7OnkJ/syedPhPt9uPXso+V/w3XLVvLwVPp+JiukvsLM+
qnYqvvvIT9bQd66jHnOZ+SUHtriHTPhuJn7ius3cq3UfYUz28t6P4uANmA/6
Dr7ie4M2+SY66zwxrodzxa8R8kNR/e8n6EJUr9gAm/1Bvvj2WcvVc5jzOed9
0nfVBddgt2uWNqLt3Im1L0Xhvp1zvH5HbfQ9Re7xrMwL6+zbXLVW55psMX+W
nXeedSzX+fqsY975/hoIuvPYQ+td59O+D8ghvgf/yvUmbIo6M3GuYn41KC/n
XdfsaZyr/c5sDarnaXNjzO+ied9rQ+7Drf+7eyiT739g/R1RPLkJ8+e5apH/
Z72G9w/zQDzL7sXt7v/sDaw78uhGc4k9YMQ4WcfPB/mfd59mjdMe7wOel+/c
KdcM31ZPBX3vcP8jn5IgvnI/37+X3S/+A6oqfAI=
         "],
         VertexColors->None], PolygonBox[CompressedData["
1:eJwllF1ozmEYxp/3/f+fP4Ywn6c7IycmtB3Mx2omZfKOfMwoTSllhUVsjrAd
jCwrUqSsbCsTGQe+mYPZnGjKgRNFOSAfececzO/qOrjfruu57vt5n+e+r+df
tq+5cCgfQqgjUuIyP30xhOUsvsqFcDYL4TQxBl6bhLATbYCoQB9l7QnaQXgC
7kevAX9nj8Xoj1jrBvewtgT+GN5O/gRrlfB15N9DO5N572rW6uDj6OXgIfJ/
wn8Q7fAOYpjc++jDnHWImsNoz1gbADfnnLuJWJq4ZhQ8Qjwk/5vOS+1c8u/k
vccY2gPWJtCa8r5rR+az6c4t4F/oNTnv2Qd+SU09uZ9ZK1VvWPuY955H0aYR
BfAn9OfgP8R5eD//tx/8npoiexVyzm2J3ks1C8GLiG74AfhT9r5LFOGD8CLa
EaKW+nPw3eCT7LcCvoqYBX9NNKC1UdOJNjW6N6pRr26y35Xgnm2Dv4OXoE+H
Z/ApxCB8Mnh2l1LPQjPUWdQz9UpnKid3AzEJb4R3gVvRv+Z8hgSeJ66Cr2nm
4N/qN/ivPEJub+pebYRPgt+Q85azdPL/M8AziQ/oqfwT7QHNvivnWdxKPVvN
5ATarmhvymPj0T1TrzSDHeDj5CwDj5BzI7WH5V31ZDT1nXQXebo32oPynmo6
omek2cgzL6JnrNnqzvJKNfX/8vbMF3iV7gyvImcreE50r0sSe31z9FuT56+D
L6Z+O2XwC6nXhDUT9XIBvDRxT+WlpuheyVN74fOje6OcUzpLaq9VwmdHn0H/
rTch7xbkkcQeLqaekWajO2gWIbr3mkk9fEtmb6mmJ/UMNTvNSG9/ffRb1zdg
ns6T2bvy2DHw9uje6xuyBr46s9fUI3m5AX1lYk/3R3tc3tY3qRX9Nrw1OKc2
8zdE3w55sA2+J/quFURj9Jqwav4DGC+oFw==
         "],
         VertexColors->None]}]}, 
     {RGBColor[0.773178312756719, 0.850515247761265, 0.9093058133367811], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1lU1s1UUUxf9fM6AJkmh0TfcVxI21CwiixS6ABy7w1ahJTTCxsTw1Rnm6
FPteIRibYD/cKWKNxIUaIyQSlQ0YuzMUw8bgyrBR+/Bjg54f93QxmTszd+6c
e++5d4Ymjxycroqi+Eaj1uhr8WJZFIuSD+ai+Kkpiju0XtHhDo3TOj+j8ZHG
QhH7yH3Jn/qcu6uaf7bM+RXrVLJZa8zJ5tUq9GaLuLdq/S9TUezJsf+05qvC
sEn6hzVOSWdZ+xv0VtY4J/l36f+hcVHn09LdWcfd23ITuP/VPCNbLenMlHH3
knQe9jnYtmt+QKMrebSJNfrMD1pul6GD/oTe7OY4Aztv8W7XOD+R/JjOxzRu
ad3S+LWM/c26M6l1r4w4XXPMJyTfkPy15I9l71vdva71FsmDMjCDf806b+n8
7Rw+48eKsRHzFeejL91/iHcRuN5zDInndeN5Sb4cB6vu7NJ8U+/tKSNvYJ+Q
/L7mJfIk/fE67OBru4o18i3Z+U9jnlxan9zNVmEbbi35DDtgQ8Yv7M0b2yHZ
eE04turOlLDc77zc1P5fKeJ4xbjwd6/OdzcRm1dS6KFztg5e8i7x6zuG5PEp
jaOSh+tYI18zz8jFb84P+Cece95ax70ez8OOYTYGOAkXps2HnjnHuwfk0xM5
+DsljBdyvLmePzgG7o5t4teMc31ZujMpcrmvjrOO8fVsn/c7xoAOMnqDJvJK
Th/XvD1H/T0KN5vwjziPNBEP8tV3LsbK2Dvq/jDrHgFe/IRj2+rIEbrHrbPs
GMJ18A014Tf9BN2tzinx67v2sUW+6C1gARM6xGfatQpPTpl7vRw1sNPvTxk/
8rDx0BeYXyiinl5OwftC8jM5+PiG9k7mqL3PJLdTvMu66/j/oL3NKWK7N0Xf
wTa9Z9nyec0fNIGfPkF/gTPk+cMmct2xPfK76Ppcdc9B//Y96Y/kiN+S5kWN
J80RdOAJvfnuHPEk79lcGTOX8Xej8JzI0XsuSb6col7h2IEqsHynve9TrI/l
6L/wlr77UA5+3aP5gtafS+e+FH18zv2j5V4Hp35sglfkeosxPaL9PyVv0/5A
d9dScIQeddr/yHgVtuACftIH1xx7bBMv8tNNkZMNmjspeNh3DcK3v1P4gy+T
tkFMRhzXtvvNJtfL68Q1BX93VdET0HmuijojN3cS4xz/HnxfNW5yOe63iQv9
hVxQY/hK/Fu167CMWtzteqQOhhwf9vf5L3tTWN7VW/u1PtMEnxb8t551XeAz
60X3HOKML+B9voq+NC8bCxqHfD7kf3xg3/rOf8vYBv5j0CFu3FvzXzfiGsT2
nPseePcbM72D2LXt90XXGjl/NccenB01b2/4z+j6bx11bsBBbMj1F/L7lxR2
h40B+1810Qfx9V6dP5sDF1jhDHfv0v47OdY9+wMH/gdF5R7E
         "],
         VertexColors->None], 
        PolygonBox[{{1229, 1387, 475, 729}, {1654, 1367, 814, 813}, {1214, 
         1201, 500, 690}, {1394, 1288, 592, 482}, {1448, 1267, 326, 451}, {
         1631, 1302, 402, 615}, {1653, 1357, 451, 559}, {1537, 1536, 666, 
         667}, {1392, 1727, 940, 365}, {1526, 1527, 593, 483}, {1606, 1604, 
         346, 766}, {1679, 1403, 491, 602}, {1670, 1669, 138, 831}, {1227, 
         1605, 766, 726}, {1630, 1629, 269, 666}, {1675, 1287, 365, 838}, {
         1592, 1626, 783, 745}, {1522, 1393, 838, 650}, {1533, 1534, 663, 
         662}, {1491, 1206, 504, 611}, {1228, 1584, 727, 728}, {1535, 1472, 
         168, 663}, {1504, 1503, 347, 577}, {1401, 1533, 662, 841}, {1676, 
         1395, 483, 592}, {1201, 1491, 611, 500}, {1671, 1672, 831, 336}, {
         1658, 1273, 336, 818}, {1472, 1524, 651, 168}, {1295, 1617, 775, 
         185}, {1481, 1401, 841, 601}, {1657, 1370, 818, 817}, {1267, 1656, 
         815, 326}, {1626, 1490, 610, 783}, {1186, 1546, 678, 152}, {1554, 
         1555, 690, 265}, {1278, 1459, 577, 346}, {1607, 1608, 728, 138}, {
         1591, 1593, 745, 269}, {1369, 1657, 817, 122}, {1619, 1618, 265, 
         775}, {1689, 1294, 602, 856}, {1415, 1301, 615, 504}, {1680, 1404, 
         847, 846}, {1402, 1480, 601, 491}, {1686, 1690, 856, 499}, {1523, 
         1522, 650, 651}, {1467, 1191, 482, 585}, {1474, 1405, 848, 593}, {
         1368, 1654, 813, 815}, {1405, 1680, 846, 848}, {1544, 1227, 726, 
         677}, {1545, 1544, 677, 678}, {1681, 1482, 185, 847}, {1584, 1229, 
         729, 727}, {1269, 1602, 559, 327}, {1187, 1467, 585, 475}, {1490, 
         1687, 855, 610}, {1727, 1190, 152, 940}, {1688, 1686, 499, 855}, {
         1655, 1454, 122, 814}},
         VertexColors->None]}]}, 
     {RGBColor[0.8382167282424244, 0.8722038263157968, 0.8801686614822312], 
      EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNVM9LlGEQnn2/fd9+QEIIdWvpr6iOLq0samsEZQYFBV7X8mK1t6JFkChM
sjp2sD8g2j3qSY1AKMjDXtKT8tVp65ZrPQ/zLHoY5v3mnXlm3plnvvP3pq/V
g5lNQzJIp2A2BVnC+WYym4QM4GI3uG7i7jp0pWjWgi2PZoPR7XXIAmwfEHsD
PjNF9y1Bn4Ps425HfvR5gLhudBtzbsvOGugfoJehV5LfEfsVZBbnL7AfT+5T
DX5PDOL9FmYO+2nkf4nzWfiegbRhi7BlmeNcgu0CZE+4IfMa/gBjFTIO+zfo
W/BZN8/POlo434XuIuYZpG2uaWftHfWwqfs1nDeA8zi67xPon/EwvqvYA9h6
kLzgNQbV+Rr53yTvK9+5bI7/A77bkJngfc1Vyz5sfyGLsE8g7mv0eq/gPJ4c
m7PZzLw29oVnzpRz4huIzx78Ux866vWUaq0r1zHczwOzFpwnTb2XHCEH2Lea
Zt/nBnM38P0J96uQ7+YzrIk/zF8SB5aSz4A4fMcvvWUA+m1yHNaXH+HgrHKx
Fvqyxw/h/xz+VeQuA3tUNbDfj9TzBfWR76Pts+zkR0VvYdxIdjjzEfXwNrDv
JOccfRnDfjLXUNH9gubH2nZUN/ORC0/FB/aG/g1h87wm7lXFhwZ8XyDXWOb1
jOktV2E7FZ3jH6EPEDtnvgvcgy3zmVS0m23VyP4bYgvJ/SrJd4z939S8WuII
Y1jPZfgMQ3rBbbuyDwmbZ+7oCe1p0N6Ru++Sc7rP5yA7a6ONfebb+7vF+ph/
S/hl9Yd7eVG7Sb6wFuZiL9fVz544PafZlTUL4u0Jkz4l/aNOAu+9dnhR/xzy
gf+h+9F5yrhcsf8B6AO4JA==
         "],
         VertexColors->None], 
        PolygonBox[{{1591, 1240, 746, 744}, {1689, 1690, 854, 379}, {1186, 
         1466, 584, 474}, {1392, 1287, 590, 480}, {1558, 1239, 743, 695}, {
         1688, 1687, 199, 854}, {1504, 1459, 136, 626}, {1402, 1678, 843, 
         183}, {1535, 1534, 490, 591}, {1679, 1294, 379, 844}, {1630, 1536, 
         400, 785}, {1293, 1613, 771, 773}, {1240, 1629, 785, 746}, {1625, 
         1514, 390, 782}, {1481, 1480, 183, 490}, {1516, 1410, 498, 609}, {
         1239, 1624, 782, 743}, {1675, 1393, 481, 590}, {1278, 1604, 765, 
         136}, {1478, 1532, 660, 182}, {1216, 1559, 695, 213}, {1606, 1605, 
         258, 765}, {1615, 1614, 166, 771}, {1299, 1623, 609, 390}, {1466, 
         1190, 480, 584}, {1292, 1616, 773, 375}, {1530, 1400, 840, 659}, {
         1678, 1403, 844, 843}, {1545, 1546, 474, 258}, {1523, 1524, 591, 
         481}, {1592, 1593, 744, 199}, {1677, 1292, 375, 840}, {1531, 1530, 
         659, 660}, {1479, 1478, 182, 498}},
         VertexColors->None]}]}, 
     {RGBColor[0.9032551437281299, 0.8938924048703287, 0.8510315096276813], 
      EdgeForm[None], 
      GraphicsGroupBox[{
        PolygonBox[{{1217, 1564, 702}, {514, 632, 231}, {630, 631, 240}, {511,
          630, 240}, {509, 268, 212}, {633, 632, 240}, {1563, 1507, 631}, {
         1410, 1516, 640}, {697, 699, 630}, {376, 196, 181}, {698, 633, 
         240}, {632, 514, 240}, {600, 641, 376}, {1623, 1299, 781}, {489, 600,
          376}, {509, 230, 197}, {1400, 1530, 489}, {510, 511, 230}, {509, 
         510, 230}, {230, 512, 197}, {638, 509, 197}, {510, 509, 212}, {236, 
         510, 212}, {1559, 1216, 696}, {1239, 1558, 268}, {512, 513, 196}, {
         377, 599, 181}, {1292, 1677, 599}, {1478, 1479, 600}, {376, 512, 
         196}, {639, 640, 197}, {641, 639, 376}, {1624, 1239, 268}, {1614, 
         1615, 772}, {514, 513, 230}, {513, 512, 230}, {599, 489, 181}, {512, 
         639, 197}, {268, 399, 212}, {240, 514, 230}, {1613, 1293, 377}, {696,
          399, 268}, {1530, 1531, 489}, {1514, 1625, 638}, {639, 512, 376}, {
         513, 514, 231}, {511, 510, 236}, {1532, 1478, 600}, {630, 511, 
         236}, {1509, 1218, 633}, {509, 638, 268}, {781, 638, 197}, {631, 698,
          240}, {697, 630, 236}, {699, 631, 630}, {489, 376, 181}, {1616, 
         1292, 599}, {699, 702, 631}, {513, 231, 196}, {1508, 1566, 632}, {
         511, 240, 230}},
         VertexColors->None], 
        PolygonBox[{{1218, 1508, 632, 633}, {1561, 1509, 633, 698}, {1507, 
         1561, 698, 631}, {1293, 1616, 599, 377}, {1515, 1410, 640, 639}, {
         1216, 1205, 399, 696}, {1531, 1532, 600, 489}, {1299, 1514, 638, 
         781}, {1558, 1559, 696, 268}, {1411, 1515, 639, 641}, {1677, 1400, 
         489, 599}, {1564, 1563, 631, 702}, {1615, 1613, 377, 772}, {1625, 
         1624, 268, 638}, {1479, 1411, 641, 600}, {1560, 1562, 699, 697}, {
         1562, 1217, 702, 699}, {1566, 1565, 231, 632}, {1516, 1489, 197, 
         640}, {1489, 1623, 781, 197}},
         VertexColors->None]}]}, 
     {RGBColor[0.941176, 0.906538, 0.834043], EdgeForm[None], 
      GraphicsGroupBox[{
        PolygonBox[{{700, 701, 244}, {1562, 1560, 244}, {1561, 1507, 271}, {
         1563, 1564, 701}, {248, 271, 211}, {1508, 1218, 248}, {701, 700, 
         271}, {1565, 1566, 703}, {1509, 1561, 271}, {1217, 1562, 244}, {271, 
         700, 211}},
         VertexColors->None], 
        PolygonBox[{{1507, 1563, 701, 271}, {1218, 1509, 271, 248}, {1566, 
         1508, 248, 703}, {1564, 1217, 244, 701}},
         VertexColors->None]}]}}, {{}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1560, 1562, 1217, 1564, 1563, 1507, 1561, 1509, 1218, 1508, 
         1566, 1565}],
        "1.5`"],
       Annotation[#, 1.5, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1205, 1216, 1559, 1558, 1239, 1624, 1625, 1514, 1299, 1623, 
         1489, 1516, 1410, 1515, 1411, 1479, 1478, 1532, 1531, 1530, 1400, 
         1677, 1292, 1616, 1293, 1613, 1615, 1614}],
        "1.25`"],
       Annotation[#, 1.25, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1503, 1504, 1459, 1278, 1604, 1606, 1605, 1227, 1544, 1545, 
         1546, 1186, 1466, 1190, 1727, 1392, 1287, 1675, 1393, 1522, 1523, 
         1524, 1472, 1535, 1534, 1533, 1401, 1481, 1480, 1402, 1678, 1403, 
         1679, 1294, 1689, 1690, 1686, 1688, 1687, 1490, 1626, 1592, 1593, 
         1591, 1240, 1629, 1630, 1536, 1537}],
        "1"],
       Annotation[#, 1, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1268, 1601, 1269, 1602, 1266, 1653, 1357, 1520, 1521, 1448, 
         1267, 1656, 1368, 1654, 1367, 1655, 1454, 1369, 1657, 1370, 1658, 
         1273, 1671, 1672, 1668, 1670, 1669, 1460, 1607, 1608, 1585, 1228, 
         1584, 1229, 1387, 1726, 1187, 1467, 1191, 1728, 1394, 1288, 1676, 
         1395, 1525, 1526, 1527, 1473, 1474, 1405, 1680, 1404, 1681, 1482, 
         1295, 1617, 1619, 1618, 1236, 1554, 1555, 1214, 1201, 1491, 1206, 
         1737, 1415, 1301, 1631, 1302, 1538, 1539}],
        "0.75`"],
       Annotation[#, 0.75, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1165, 1436, 1256, 1597, 1599, 1598, 1224, 1541, 1542, 1543, 
         1168, 1440, 1171, 1711, 1349, 1263, 1350, 1712, 1172, 1444, 1175, 
         1715, 1358, 1270, 1359, 1716, 1176, 1449, 1450, 1372, 1659, 1371, 
         1660, 1455, 1373, 1661, 1374, 1662, 1274, 1381, 1752, 1380, 1461, 
         1279, 1741, 1280, 1230, 1547, 1548, 1549, 1188, 1468, 1192, 1729, 
         1396, 1289, 1397, 1730, 1193, 1475, 1197, 1733, 1406, 1484, 1483, 
         1296, 1620, 1297, 1621, 1237, 1556, 1557, 1215, 1202, 1492, 1207, 
         1738, 1416, 1303, 1304, 1739, 1208}],
        "0.5`"],
       Annotation[#, 0.5, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1209, 1740, 1305, 1242, 1594, 1241, 1595, 1628, 1627, 1493, 
         1692, 1412, 1691, 1413, 1486, 1485, 1199, 1735, 1408, 1298, 1407, 
         1734, 1198, 1476, 1194, 1212, 1553, 1552, 1232, 1286, 1743, 1285, 
         1469, 1388, 1754, 1389, 1282, 1462, 1184, 1724, 1383, 1281, 1382, 
         1723, 1183, 1456, 1181, 1721, 1376, 1275, 1375, 1720, 1180, 1451, 
         1177, 1717, 1360, 1225, 1578, 1580, 1579, 1600, 1445, 1649, 1650, 
         1648, 1652, 1651, 1260, 1342, 1747, 1341, 1441, 1339, 1746, 1340, 
         1257, 1646, 1647, 1645, 1332, 1437, 1643, 1330, 1642, 1331, 1644, 
         1253, 1641, 1323, 1640, 1322, 1433, 1638, 1320, 1637, 1321, 1639, 
         1246, 1634, 1314, 1633, 1313, 1426, 1427, 1248, 1596, 1247}],
        "0.25`"],
       Annotation[#, 0.25, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1496, 1495, 1694, 1695, 1693, 1417, 1696, 1300, 1494, 1203, 
         1736, 1414, 1238, 1588, 1590, 1589, 1622, 1487, 1683, 1684, 1682, 
         1409, 1685, 1291, 1477, 1196, 1732, 1399, 1290, 1398, 1731, 1195, 
         1470, 1189, 1211, 1551, 1550, 1231, 1284, 1742, 1283, 1463, 1384, 
         1753, 1385, 1277, 1379, 1751, 1378, 1457, 1276, 1377, 1722, 1182, 
         1452, 1179, 1719, 1362, 1271, 1361, 1718, 1178, 1446, 1174, 1714, 
         1352, 1264, 1351, 1713, 1173, 1442, 1170, 1710, 1344, 1261, 1343, 
         1709, 1169, 1438, 1167, 1708, 1334, 1258, 1333, 1707, 1166, 1434, 
         1161, 1706, 1325, 1254, 1324, 1705, 1160, 1428, 1155, 1701, 1316, 
         1249, 1315, 1700, 1154, 1420, 1150, 1697, 1306, 1243, 1497, 1498, 
         1418, 1419, 1149, 1499, 1500}],
        "0"],
       Annotation[#, 0, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1204, 1488, 1200, 1213, 1506, 1505, 1235, 1513, 1529, 1528, 
         1612, 1611, 1234, 1586, 1233, 1587, 1610, 1609, 1471, 1674, 1390, 
         1673, 1391, 1465, 1464, 1185, 1725, 1386, 1226, 1581, 1583, 1582, 
         1603, 1458, 1664, 1665, 1663, 1667, 1666, 1272, 1366, 1750, 1365, 
         1453, 1363, 1761, 1364, 1265, 1356, 1749, 1355, 1447, 1353, 1760, 
         1354, 1262, 1348, 1748, 1347, 1443, 1345, 1759, 1346, 1259, 1338, 
         1745, 1337, 1439, 1335, 1758, 1336, 1255, 1329, 1744, 1328, 1435, 
         1326, 1757, 1327, 1223, 1571, 1222, 1572, 1162, 1429, 1157, 1703, 
         1318, 1250, 1317, 1702, 1156, 1422, 1151, 1698, 1309, 1244, 1632, 
         1308, 1517, 1518, 1519, 1421, 1501, 1307}],
        RowBox[{"-", "0.25`"}]],
       Annotation[#, -0.25, "Tooltip"]& ]}, 
     {GrayLevel[0], Opacity[0.4], 
      TagBox[
       TooltipBox[
        LineBox[{1164, 1576, 1577, 1573, 1575, 1574, 1163, 1432, 1159, 1704, 
         1319, 1431, 1430, 1636, 1210, 1635, 1540, 1221, 1570, 1251, 1755, 
         1252, 1220, 1567, 1569, 1568, 1158, 1425, 1153, 1699, 1312, 1245, 
         1424, 1310, 1756, 1311, 1219, 1510, 1512, 1511, 1152, 1423, 1502}],
        RowBox[{"-", "0.5`"}]],
       Annotation[#, -0.5, "Tooltip"]& ]}, {}, {}}, {InsetBox[
      RowBox[{"-", "0.5`"}], 1762], InsetBox[
      RowBox[{"-", "0.25`"}], 1763], InsetBox["0", 1764], 
     InsetBox["0.25`", 1765], InsetBox["0.5`", 1766], InsetBox["0.75`", 1767],
      InsetBox["1", 1768], InsetBox["1.25`", 1769], InsetBox["1.5`", 1770]}}],
  
  AspectRatio->1,
  Frame->True,
  ImageMargins->{{0., 431.}, {205., 0.}},
  ImageSize->{716., Automatic},
  PlotRange->{{-0.8, 0.8}, {-0.2, 0.2}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Input",
 CellChangeTimes->{
  3.490427585812654*^9, 3.490427690778436*^9, {3.490427833972465*^9, 
   3.490427837662134*^9}, 3.490428016959746*^9, {3.490428257974122*^9, 
   3.490428265460681*^9}, {3.490617016349694*^9, 3.490617019070925*^9}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{"\[Kappa]", " ", "\[Equal]", " ", 
     RowBox[{
      SqrtBox[
       RowBox[{
        SuperscriptBox["p", "2"], "+", 
        SuperscriptBox["MBB", "2"]}]], "+", " ", 
      SqrtBox[
       RowBox[{
        SuperscriptBox["Mm", "2"], "+", 
        SuperscriptBox["p", "2"], "+", 
        SuperscriptBox["q", "2"], "-", 
        RowBox[{"2", "A", "*", "p"}]}]]}]}], ",", "p"}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.490617036159502*^9, 3.490617082447192*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"p", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"A", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["MBB", "2"]}], "+", 
          SuperscriptBox["Mm", "2"], "+", 
          SuperscriptBox["q", "2"], "-", 
          SuperscriptBox["\[Kappa]", "2"]}], ")"}]}], "-", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["\[Kappa]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", " ", 
            SuperscriptBox["A", "2"], " ", 
            SuperscriptBox["MBB", "2"]}], "+", 
           SuperscriptBox["MBB", "4"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["Mm", "2"], "+", 
              SuperscriptBox["q", "2"], "-", 
              SuperscriptBox["\[Kappa]", "2"]}], ")"}], "2"], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["MBB", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["Mm", "2"], "+", 
              SuperscriptBox["q", "2"], "+", 
              SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]}], ")"}]}]]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "-", 
         SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"A", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["MBB", "2"]}], "+", 
          SuperscriptBox["Mm", "2"], "+", 
          SuperscriptBox["q", "2"], "-", 
          SuperscriptBox["\[Kappa]", "2"]}], ")"}]}], "+", 
       SqrtBox[
        RowBox[{
         SuperscriptBox["\[Kappa]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"4", " ", 
            SuperscriptBox["A", "2"], " ", 
            SuperscriptBox["MBB", "2"]}], "+", 
           SuperscriptBox["MBB", "4"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["Mm", "2"], "+", 
              SuperscriptBox["q", "2"], "-", 
              SuperscriptBox["\[Kappa]", "2"]}], ")"}], "2"], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["MBB", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox["Mm", "2"], "+", 
              SuperscriptBox["q", "2"], "+", 
              SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]}], ")"}]}]]}], 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["A", "2"], "-", 
         SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490617025420734*^9, {3.490617057697206*^9, 3.490617084374425*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CForm", "[", 
  FractionBox[
   RowBox[{
    RowBox[{"A", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox["MBB", "2"]}], "+", 
       SuperscriptBox["Mm", "2"], "+", 
       SuperscriptBox["q", "2"], "-", 
       SuperscriptBox["\[Kappa]", "2"]}], ")"}]}], "-", 
    SqrtBox[
     RowBox[{
      SuperscriptBox["\[Kappa]", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         SuperscriptBox["A", "2"], " ", 
         SuperscriptBox["MBB", "2"]}], "+", 
        SuperscriptBox["MBB", "4"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["Mm", "2"], "+", 
           SuperscriptBox["q", "2"], "-", 
           SuperscriptBox["\[Kappa]", "2"]}], ")"}], "2"], "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["MBB", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["Mm", "2"], "+", 
           SuperscriptBox["q", "2"], "+", 
           SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]}], ")"}]}]]}], 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["A", "2"], "-", 
      SuperscriptBox["\[Kappa]", "2"]}], ")"}]}]], "]"}]], "Input",
 CellChangeTimes->{{3.490617103509884*^9, 3.490617110213415*^9}}],

Cell["\<\
(A*(-Power(MBB,2) + Power(Mm,2) + Power(q,2) - Power(\[Kappa],2)) - 
     Sqrt(Power(\[Kappa],2)*(4*Power(A,2)*Power(MBB,2) + Power(MBB,4) + 
         Power(Power(Mm,2) + Power(q,2) - Power(\[Kappa],2),2) - 
         2*Power(MBB,2)*(Power(Mm,2) + Power(q,2) + Power(\[Kappa],2)))))/
   (2.*(Power(A,2) - Power(\[Kappa],2)))\
\>", "Output",
 CellChangeTimes->{3.490617110653706*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1053, 903},
WindowMargins->{{Automatic, 61}, {41, Automatic}},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 1474, 39, 169, "Input"],
Cell[2067, 64, 86, 1, 28, "Output"],
Cell[2156, 67, 89, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2282, 73, 90, 1, 72, "Section"],
Cell[CellGroupData[{
Cell[2397, 78, 1523, 40, 169, "Input"],
Cell[3923, 120, 110, 1, 28, "Output"],
Cell[4036, 123, 111, 1, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4196, 130, 139, 2, 72, "Section"],
Cell[CellGroupData[{
Cell[4360, 136, 1571, 40, 169, "Input"],
Cell[5934, 178, 134, 2, 28, "Output"],
Cell[6071, 182, 135, 2, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6255, 190, 234, 3, 72, "Section"],
Cell[CellGroupData[{
Cell[6514, 197, 1760, 43, 169, "Input"],
Cell[8277, 242, 224, 3, 28, "Output"],
Cell[8504, 247, 225, 3, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8778, 256, 188, 3, 72, "Section"],
Cell[CellGroupData[{
Cell[8991, 263, 1712, 42, 295, "Input"],
Cell[10706, 307, 203, 3, 28, "Output"],
Cell[10912, 312, 203, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11152, 320, 1815, 45, 320, "Input"],
Cell[12970, 367, 277, 4, 28, "Output"],
Cell[13250, 373, 278, 4, 28, "Output"],
Cell[13531, 379, 268, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13836, 388, 1744, 44, 295, "Input"],
Cell[15583, 434, 230, 4, 28, "Output"],
Cell[15816, 440, 231, 4, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16096, 450, 188, 3, 72, "Section"],
Cell[CellGroupData[{
Cell[16309, 457, 1616, 41, 295, "Input"],
Cell[17928, 500, 184, 3, 28, "Output"],
Cell[18115, 505, 185, 3, 28, "Output"]
}, Open  ]],
Cell[18315, 511, 697, 18, 64, "Input"],
Cell[19015, 531, 4575, 120, 458, "Input"],
Cell[23593, 653, 115, 2, 40, "Input"],
Cell[CellGroupData[{
Cell[23733, 659, 2091, 58, 225, "Input"],
Cell[25827, 719, 671, 14, 98, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26535, 738, 2041, 57, 225, "Input"],
Cell[28579, 797, 647, 13, 98, "Output"]
}, Open  ]],
Cell[29241, 813, 68, 1, 40, "Input"],
Cell[CellGroupData[{
Cell[29334, 818, 296, 7, 40, "Input"],
Cell[29633, 827, 2734, 74, 114, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32404, 906, 269, 6, 40, "Input"],
Cell[32676, 914, 177, 3, 28, "Output"]
}, Open  ]],
Cell[32868, 920, 1376, 37, 78, "Input"],
Cell[34247, 959, 82597, 1380, 1393, 52084, 878, "CachedBoxData", "BoxData", \
"Input"],
Cell[CellGroupData[{
Cell[116869, 2343, 561, 17, 64, "Input"],
Cell[117433, 2362, 2847, 83, 150, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120317, 2450, 1298, 39, 162, "Input"],
Cell[121618, 2491, 391, 7, 100, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
