(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     30643,        945]
NotebookOptionsPosition[     28664,        874]
NotebookOutlinePosition[     29260,        895]
CellTagsIndexPosition[     29217,        892]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["DataPoints", "Section",
 CellChangeTimes->{{3.491709892125859*^9, 3.491709897589167*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SettingsSVL", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.13"}], ",", " ", 
       RowBox[{"-", "13.5294"}], ",", " ", 
       RowBox[{"-", "0.065"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.028", ",", " ", "13.0198", ",", " ", 
       RowBox[{"-", "0.218"}]}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5.692"}], ",", " ", "0.168184", ",", " ", 
       RowBox[{"-", "4.482"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.689", ",", " ", "0.168184", ",", " ", "4.078"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4.236"}], ",", " ", "0.168184", ",", " ", "5.515"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "5.806"}], ",", " ", "0.168184", ",", " ", 
       RowBox[{"-", "4.622"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5.593", ",", " ", "0.168184", ",", " ", "4.061"}], "}"}], ",", 
     
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4.238"}], ",", " ", "0.168184", ",", " ", "5.527"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4.286", ",", " ", "0.168184", ",", " ", 
       RowBox[{"-", "6.001"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.022", ",", " ", "13.0198", ",", " ", 
       RowBox[{"-", "0.218"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.491708826921593*^9, 3.491709055940658*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SettingsSVL", "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.491709061186066*^9, 3.4917090739721*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"-", "0.13`"}], 
     RowBox[{"-", "13.5294`"}], 
     RowBox[{"-", "0.065`"}]},
    {"0.028`", "13.0198`", 
     RowBox[{"-", "0.218`"}]},
    {
     RowBox[{"-", "5.692`"}], "0.168184`", 
     RowBox[{"-", "4.482`"}]},
    {"5.689`", "0.168184`", "4.078`"},
    {
     RowBox[{"-", "4.236`"}], "0.168184`", "5.515`"},
    {
     RowBox[{"-", "5.806`"}], "0.168184`", 
     RowBox[{"-", "4.622`"}]},
    {"5.593`", "0.168184`", "4.061`"},
    {
     RowBox[{"-", "4.238`"}], "0.168184`", "5.527`"},
    {"4.286`", "0.168184`", 
     RowBox[{"-", "6.001`"}]},
    {"0.022`", "13.0198`", 
     RowBox[{"-", "0.218`"}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.7]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.491709069509357*^9, 3.491709074338582*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Parameters", "Section",
 CellChangeTimes->{{3.491709889394202*^9, 3.491709906091676*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Aa", " ", "=", " ", "0.0248"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ErrAa", " ", "=", " ", "0.0123"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bb", " ", "=", " ", "0.1565"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ErrBb", " ", "=", " ", "0.0377"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rr", " ", "=", " ", "0.99745"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ErrRr", " ", "=", " ", "0.00130"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Kk", " ", "=", " ", "0.550365"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ErrKk", " ", "=", " ", "0.008133"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ee", " ", "=", " ", "0.168082"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ErrEe", " ", "=", " ", "0.06048"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.491709923144433*^9, 3.491710037602788*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calculations", "Section",
 CellChangeTimes->{{3.491709913096771*^9, 3.491709914642755*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PhiBar", "[", 
   RowBox[{"{", 
    RowBox[{"IS_", ",", " ", "IV_", ",", "IL_"}], "}"}], " ", "]"}], ":=", 
  RowBox[{"ArcTan", "[", 
   RowBox[{
    RowBox[{"Kk", 
     RowBox[{"(", 
      RowBox[{"IV", "+", "Ee"}], ")"}]}], ",", 
    SqrtBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"IS", " ", "+", " ", "Aa"}], ")"}], "2"], "+", 
      RowBox[{
       SuperscriptBox["Rr", "2"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"IL", "+", "Bb"}], ")"}], "2"]}]}]]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.49170968129249*^9, 3.491709785249373*^9}, {
  3.491709838266918*^9, 3.491709838510943*^9}, {3.491726923261728*^9, 
  3.491726926506926*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ThetaBar", "[", 
   RowBox[{"{", 
    RowBox[{"IS_", ",", " ", "IV_", ",", "IL_"}], "}"}], " ", "]"}], ":=", 
  RowBox[{"ArcTan", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"IS", " ", "+", " ", "Aa"}], ")"}], ",", 
    RowBox[{"Rr", 
     RowBox[{"(", 
      RowBox[{"IL", "+", "Bb"}], ")"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.491709845055338*^9, 3.491709881736604*^9}, {
  3.491713474354869*^9, 3.491713498809359*^9}, {3.491714120186124*^9, 
  3.49171412126757*^9}, {3.491714230556732*^9, 3.491714233001082*^9}, {
  3.49172324695296*^9, 3.4917232502715*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Vertical Compass", "Section",
 CellChangeTimes->{{3.491726780885113*^9, 3.491726787422301*^9}, {
  3.491726859200537*^9, 3.491726866043406*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["180", "\[Pi]"], "*", 
      RowBox[{"PhiBar", "[", "#", "]"}]}], "&"}], ",", " ", "SettingsSVL"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.491726866944619*^9, 3.491726877449174*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "178.91498953862546`", ",", "0.6388910063998202`", ",", 
   "88.51160389278375`", ",", "88.50800383258762`", ",", "88.49678852109037`",
    ",", "88.54736314494394`", ",", "88.48948687041201`", ",", 
   "88.49908545340405`", ",", "88.53780696384159`", ",", 
   "0.6090550753977582`"}], "}"}]], "Output",
 CellChangeTimes->{3.491726878369455*^9, 3.49172692895756*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"ArcTan", "[", 
    RowBox[{
     RowBox[{"pKk", 
      RowBox[{"(", 
       RowBox[{"IV", "+", "pEe"}], ")"}]}], ",", 
     SqrtBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"IS", " ", "+", " ", "pAa"}], ")"}], "2"], "+", 
       RowBox[{
        SuperscriptBox["pRr", "2"], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"IL", "+", "pBb"}], ")"}], "2"]}]}]]}], "]"}], ",", "pBb"}],
   " ", "]"}]], "Input",
 CellChangeTimes->{{3.491726998512038*^9, 3.491727026449508*^9}, {
  3.491727092243467*^9, 3.49172709271277*^9}, {3.491727158654576*^9, 
  3.49172715924502*^9}, {3.491727199290619*^9, 3.491727199944528*^9}, {
  3.491727246336624*^9, 3.491727247273781*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"IL", "+", "pBb"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"IV", "+", "pEe"}], ")"}], " ", "pKk", " ", 
   SuperscriptBox["pRr", "2"]}], 
  RowBox[{
   SqrtBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"IS", "+", "pAa"}], ")"}], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"IL", "+", "pBb"}], ")"}], "2"], " ", 
      SuperscriptBox["pRr", "2"]}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"IS", "+", "pAa"}], ")"}], "2"], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"IV", "+", "pEe"}], ")"}], "2"], " ", 
      SuperscriptBox["pKk", "2"]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"IL", "+", "pBb"}], ")"}], "2"], " ", 
      SuperscriptBox["pRr", "2"]}]}], ")"}]}]]], "Output",
 CellChangeTimes->{{3.491727021030124*^9, 3.491727026870426*^9}, 
   3.491727093276364*^9, 3.491727159838937*^9, 3.491727200318648*^9, 
   3.491727247829044*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"PhiBarWithError", "[", 
   RowBox[{"{", 
    RowBox[{"IS_", ",", " ", "IV_", ",", "IL_"}], "}"}], " ", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ArcTan", "[", 
     RowBox[{
      RowBox[{"Kk", 
       RowBox[{"(", 
        RowBox[{"IV", "+", "Ee"}], ")"}]}], ",", 
      SqrtBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"IS", " ", "+", " ", "Aa"}], ")"}], "2"], "+", 
        RowBox[{
         SuperscriptBox["Rr", "2"], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"IL", "+", "Bb"}], ")"}], "2"]}]}]]}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{"IV", "+", "Ee"}], ")"}], " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
             SuperscriptBox["Rr", "2"]}]}]]}], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IV", "+", "Ee"}], ")"}], "2"], " ", 
           SuperscriptBox["Kk", "2"]}], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
           SuperscriptBox["Rr", "2"]}]}]]}], "]"}], "*", "ErrKk"}], "+", 
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"Kk", " ", 
          SqrtBox[
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
             SuperscriptBox["Rr", "2"]}]}]]}], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IV", "+", "Ee"}], ")"}], "2"], " ", 
           SuperscriptBox["Kk", "2"]}], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
           SuperscriptBox["Rr", "2"]}]}]]}], "]"}], "*", "ErrEe"}], "+", 
     RowBox[{
      RowBox[{"Abs", "[", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"IS", "+", "Aa"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"IV", "+", "Ee"}], ")"}], " ", "Kk"}], 
        RowBox[{
         SqrtBox[
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
            SuperscriptBox["Rr", "2"]}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IV", "+", "Ee"}], ")"}], "2"], " ", 
            SuperscriptBox["Kk", "2"]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
            SuperscriptBox["Rr", "2"]}]}], ")"}]}]], "]"}], "*", "ErrAa"}], 
     " ", "+", 
     RowBox[{
      RowBox[{"Abs", "[", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{"IV", "+", "Ee"}], ")"}], " ", "Kk", " ", "Rr"}], 
        RowBox[{
         SqrtBox[
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
            SuperscriptBox["Rr", "2"]}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IV", "+", "Ee"}], ")"}], "2"], " ", 
            SuperscriptBox["Kk", "2"]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
            SuperscriptBox["Rr", "2"]}]}], ")"}]}]], "]"}], "*", "ErrRr"}], 
     "+", " ", 
     RowBox[{
      RowBox[{"Abs", "[", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"IL", "+", "Bb"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"IV", "+", "Ee"}], ")"}], " ", "Kk", " ", 
         SuperscriptBox["Rr", "2"]}], 
        RowBox[{
         SqrtBox[
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IL", "+", "Bb"}], ")"}], "2"], 
            SuperscriptBox["Rr", "2"]}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IV", "+", "Ee"}], ")"}], "2"], " ", 
            SuperscriptBox["Kk", "2"]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
            SuperscriptBox["Rr", "2"]}]}], ")"}]}]], "]"}], "*", 
      "ErrBb"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.491727038154741*^9, 3.491727118917365*^9}, {
  3.49172715273267*^9, 3.49172727463309*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Flatten", "[", "#", "]"}], ",", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["180", "\[Pi]"], "*", 
         RowBox[{"First", "[", 
          RowBox[{"PhiBarWithError", "[", "#", "]"}], "]"}]}], ")"}], ",", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["180", "\[Pi]"], "*", 
         RowBox[{"Last", "[", 
          RowBox[{"PhiBarWithError", "[", "#", "]"}], "]"}]}], ")"}]}], "}"}],
      "&"}], ",", " ", "SettingsSVL"}], "]"}], "//", "MatrixForm"}]], "Input",\

 CellChangeTimes->{{3.491727306667473*^9, 3.491727316714203*^9}, {
  3.491731081933875*^9, 3.491731083829651*^9}, {3.491731243039399*^9, 
  3.491731244902269*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.13`"}], ",", 
        RowBox[{"-", "13.5294`"}], ",", 
        RowBox[{"-", "0.065`"}]}], "}"}], "178.91498953862546`", 
      "0.28584375895156183`"},
     {
      RowBox[{"{", 
       RowBox[{"0.028`", ",", "13.0198`", ",", 
        RowBox[{"-", "0.218`"}]}], "}"}], "0.6388910063998202`", 
      "0.301135847556098`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "5.692`"}], ",", "0.168184`", ",", 
        RowBox[{"-", "4.482`"}]}], "}"}], "88.51160389278375`", 
      "0.29707717073586903`"},
     {
      RowBox[{"{", 
       RowBox[{"5.689`", ",", "0.168184`", ",", "4.078`"}], "}"}], 
      "88.50800383258762`", "0.2977178449791995`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "4.236`"}], ",", "0.168184`", ",", "5.515`"}], "}"}], 
      "88.49678852109037`", "0.3016946818984102`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "5.806`"}], ",", "0.168184`", ",", 
        RowBox[{"-", "4.622`"}]}], "}"}], "88.54736314494394`", 
      "0.289822594357781`"},
     {
      RowBox[{"{", 
       RowBox[{"5.593`", ",", "0.168184`", ",", "4.061`"}], "}"}], 
      "88.48948687041201`", "0.3015365001986237`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "4.238`"}], ",", "0.168184`", ",", "5.527`"}], "}"}], 
      "88.49908545340405`", "0.3012254773267258`"},
     {
      RowBox[{"{", 
       RowBox[{"4.286`", ",", "0.168184`", ",", 
        RowBox[{"-", "6.001`"}]}], "}"}], "88.53780696384159`", 
      "0.2932712033349984`"},
     {
      RowBox[{"{", 
       RowBox[{"0.022`", ",", "13.0198`", ",", 
        RowBox[{"-", "0.218`"}]}], "}"}], "0.6090550753977582`", 
      "0.3071590058955779`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.491727318256359*^9, 3.491731084203852*^9, 
  3.491731245257952*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Horizontal Compass", "Section",
 CellChangeTimes->{{3.491726780885113*^9, 3.491726787422301*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "180"}], "+", 
     RowBox[{"(", 
      RowBox[{"143", "+", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["180", "\[Pi]"], "*", 
         RowBox[{"ThetaBar", "[", "#", "]"}]}], ")"}]}], ")"}]}], "&"}], ",", 
   " ", "SettingsSVL"}], "]"}]], "Input",
 CellChangeTimes->{{3.49171034270581*^9, 3.491710344212623*^9}, {
  3.491710419540433*^9, 3.491710427413242*^9}, {3.491712237872277*^9, 
  3.491712254559107*^9}, {3.491714242911655*^9, 3.491714296811392*^9}, {
  3.491715351412168*^9, 3.491715355012855*^9}, {3.491715410257813*^9, 
  3.491715425959287*^9}, {3.491715618770479*^9, 3.491715634100976*^9}, {
  3.491715899577092*^9, 3.4917159243485*^9}, {3.491716400287079*^9, 
  3.491716424933825*^9}, {3.49171882806422*^9, 3.491718830590115*^9}, {
  3.491718871325153*^9, 3.491718871502119*^9}, {3.491719314568543*^9, 
  3.491719331835646*^9}, {3.491723260017609*^9, 3.491723281022857*^9}, {
  3.491723452200947*^9, 3.491723457343155*^9}, {3.491725479444767*^9, 
  3.491725481292735*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"102.05659807475587`", ",", 
   RowBox[{"-", "86.28038648246999`"}], ",", 
   RowBox[{"-", "179.71778581438465`"}], ",", 
   RowBox[{"-", "0.5277921169805779`"}], ",", "89.664656211965`", ",", 
   RowBox[{"-", "179.38762425188483`"}], ",", 
   RowBox[{"-", "0.17323733044202072`"}], ",", "89.61969201280255`", ",", 
   RowBox[{"-", "90.51826030556379`"}], ",", 
   RowBox[{"-", "89.65922728489974`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.491710345164168*^9, {3.491710422970865*^9, 3.491710428262205*^9}, {
   3.49171223918231*^9, 3.491712254862427*^9}, {3.491713479079997*^9, 
   3.491713501204321*^9}, {3.491714238480682*^9, 3.491714274230734*^9}, 
   3.491715355650401*^9, {3.491715411989923*^9, 3.491715426550835*^9}, {
   3.491715623199263*^9, 3.491715634825073*^9}, {3.491715906499436*^9, 
   3.491715925200304*^9}, {3.491716404304633*^9, 3.491716425617728*^9}, {
   3.491718831513923*^9, 3.491718871997136*^9}, {3.49171932381525*^9, 
   3.491719332778369*^9}, {3.491723255858438*^9, 3.491723308380741*^9}, 
   3.491723457958224*^9, 3.49172399947758*^9, 3.491725481755854*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "37"}], "+", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["180", "\[Pi]"], "*", 
       RowBox[{"ThetaBar", "[", "#", "]"}]}], ")"}]}], "&"}], ",", " ", 
   "SettingsSVL"}], "]"}]], "Input",
 CellChangeTimes->{{3.491718908162156*^9, 3.491718909173355*^9}, {
  3.49172513325526*^9, 3.49172514467921*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"102.05659807475587`", ",", 
   RowBox[{"-", "86.28038648246999`"}], ",", 
   RowBox[{"-", "179.71778581438465`"}], ",", 
   RowBox[{"-", "0.5277921169805779`"}], ",", "89.66465621196498`", ",", 
   RowBox[{"-", "179.38762425188483`"}], ",", 
   RowBox[{"-", "0.1732373304420065`"}], ",", "89.61969201280256`", ",", 
   RowBox[{"-", "90.51826030556379`"}], ",", 
   RowBox[{"-", "89.65922728489974`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.491718909689408*^9, {3.491723301751648*^9, 3.491723306470699*^9}, 
   3.491725145525109*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"ArcTan", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"IS", " ", "+", " ", "pAa"}], ")"}], ",", 
     RowBox[{"pRr", 
      RowBox[{"(", 
       RowBox[{"IL", "+", "pBb"}], ")"}]}]}], "]"}], ",", " ", "pRr"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.491726305589732*^9, 3.491726306498653*^9}, {
  3.49172643693165*^9, 3.491726523562032*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"IS", "+", "pAa"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"IL", "+", "pBb"}], ")"}]}], 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"IS", "+", "pAa"}], ")"}], "2"], "+", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"IL", "+", "pBb"}], ")"}], "2"], " ", 
    SuperscriptBox["pRr", "2"]}]}]]], "Output",
 CellChangeTimes->{{3.491726446200289*^9, 3.491726468887209*^9}, {
  3.491726499334141*^9, 3.491726523914102*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ThetaBarWithError", "[", 
   RowBox[{"{", 
    RowBox[{"IS_", ",", " ", "IV_", ",", "IL_"}], "}"}], " ", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ArcTan", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"IS", " ", "+", " ", "Aa"}], ")"}], ",", 
      RowBox[{"Rr", 
       RowBox[{"(", 
        RowBox[{"IL", "+", "Bb"}], ")"}]}]}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{"IL", "+", "Bb"}], ")"}], " ", "Rr"}], 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"IL", "+", "Bb"}], ")"}], "2"], 
           SuperscriptBox["Rr", "2"]}]}]]}], "]"}], "*", "ErrAa"}], "+", 
     RowBox[{
      RowBox[{"Abs", "[", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"IS", "+", "Aa"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"IL", "+", "Bb"}], ")"}]}], 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
          SuperscriptBox["Rr", "2"]}]}]], "]"}], "*", "ErrRr"}], "+", 
     RowBox[{
      RowBox[{"Abs", "[", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"IS", "+", "Aa"}], ")"}], "Rr"}], 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"IS", "+", "Aa"}], ")"}], "2"], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"IL", "+", "Bb"}], ")"}], "2"], " ", 
          SuperscriptBox["Rr", "2"]}]}]], "]"}], "*", "ErrBb"}]}]}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.491726314047145*^9, 3.49172632713689*^9}, {
   3.491726484166154*^9, 3.49172653518171*^9}, 3.491726746660592*^9, {
   3.491727135866782*^9, 3.491727136572229*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Flatten", "[", "#", "]"}], ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["180", "\[Pi]"], "*", 
          RowBox[{"First", "[", 
           RowBox[{"ThetaBarWithError", "[", "#", "]"}], "]"}]}], "-", "37"}],
         ")"}], ",", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["180", "\[Pi]"], "*", 
         RowBox[{"Last", "[", 
          RowBox[{"ThetaBarWithError", "[", "#", "]"}], "]"}]}], ")"}]}], 
      "}"}], "&"}], ",", " ", "SettingsSVL"}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.491726343074436*^9, 3.491726351061927*^9}, {
  3.491726565266197*^9, 3.49172665761227*^9}, {3.491726702543543*^9, 
  3.49172670913409*^9}, {3.491726837271675*^9, 3.49172685171871*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.13`"}], ",", 
        RowBox[{"-", "13.5294`"}], ",", 
        RowBox[{"-", "0.065`"}]}], "}"}], "102.05659807475587`", 
      "15.038371773878566`"},
     {
      RowBox[{"{", 
       RowBox[{"0.028`", ",", "13.0198`", ",", 
        RowBox[{"-", "0.218`"}]}], "}"}], 
      RowBox[{"-", "86.28038648246999`"}], "24.00195284284124`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "5.692`"}], ",", "0.168184`", ",", 
        RowBox[{"-", "4.482`"}]}], "}"}], 
      RowBox[{"-", "179.71778581438465`"}], "0.33660677981973774`"},
     {
      RowBox[{"{", 
       RowBox[{"5.689`", ",", "0.168184`", ",", "4.078`"}], "}"}], 
      RowBox[{"-", "0.5277921169805779`"}], "0.33848975040669976`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "4.236`"}], ",", "0.168184`", ",", "5.515`"}], "}"}], 
      "89.66465621196498`", "0.29835192617417083`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "5.806`"}], ",", "0.168184`", ",", 
        RowBox[{"-", "4.622`"}]}], "}"}], 
      RowBox[{"-", "179.38762425188483`"}], "0.32890076851901623`"},
     {
      RowBox[{"{", 
       RowBox[{"5.593`", ",", "0.168184`", ",", "4.061`"}], "}"}], 
      RowBox[{"-", "0.1732373304420065`"}], "0.34174678905890243`"},
     {
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "4.238`"}], ",", "0.168184`", ",", "5.527`"}], "}"}], 
      "89.61969201280256`", "0.29778830822960145`"},
     {
      RowBox[{"{", 
       RowBox[{"4.286`", ",", "0.168184`", ",", 
        RowBox[{"-", "6.001`"}]}], "}"}], 
      RowBox[{"-", "90.51826030556379`"}], "0.2905374787596471`"},
     {
      RowBox[{"{", 
       RowBox[{"0.022`", ",", "13.0198`", ",", 
        RowBox[{"-", "0.218`"}]}], "}"}], 
      RowBox[{"-", "89.65922728489974`"}], "24.235242472981366`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.491726344964202*^9, 3.491726351537017*^9}, {
   3.491726537488502*^9, 3.491726567398458*^9}, {3.491726610476042*^9, 
   3.491726621070666*^9}, 3.491726662398699*^9, 3.491726709584693*^9, 
   3.491726752300404*^9, {3.491726839670762*^9, 3.491726852028065*^9}, 
   3.491727139778652*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{898, 765},
WindowMargins->{{150, Automatic}, {Automatic, 52}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1.,
"PaperOrientation"->"Portrait",
"PaperSize"->{611.25, 789.5625},
"PostScriptOutputFile"->"/home/miham/Hive/JLab/e05102/Optics4/\
TargetPhCalibration/TrueFieldOrientation.nb.ps"},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 95, 1, 72, "Section"],
Cell[688, 26, 1465, 41, 63, "Input"],
Cell[CellGroupData[{
Cell[2178, 71, 132, 2, 28, "Input"],
Cell[2313, 75, 1190, 37, 198, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3552, 118, 95, 1, 72, "Section"],
Cell[3650, 121, 960, 23, 199, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4647, 149, 97, 1, 72, "Section"],
Cell[4747, 152, 733, 22, 43, "Input"],
Cell[5483, 176, 611, 15, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6131, 196, 150, 2, 72, "Section"],
Cell[CellGroupData[{
Cell[6306, 202, 315, 9, 64, "Input"],
Cell[6624, 213, 408, 8, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7069, 226, 776, 22, 43, "Input"],
Cell[7848, 250, 1108, 36, 61, "Output"]
}, Open  ]],
Cell[8971, 289, 6280, 191, 273, "Input"],
Cell[CellGroupData[{
Cell[15276, 484, 781, 22, 66, "Input"],
Cell[16060, 508, 2395, 69, 198, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18504, 583, 103, 1, 72, "Section"],
Cell[CellGroupData[{
Cell[18632, 588, 1089, 23, 47, "Input"],
Cell[19724, 613, 1128, 19, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20889, 637, 402, 12, 47, "Input"],
Cell[21294, 651, 578, 12, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21909, 668, 407, 12, 28, "Input"],
Cell[22319, 682, 526, 17, 51, "Output"]
}, Open  ]],
Cell[22860, 702, 2149, 66, 108, "Input"],
Cell[CellGroupData[{
Cell[25034, 772, 873, 24, 66, "Input"],
Cell[25910, 798, 2726, 72, 198, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
