(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      7318,        228]
NotebookOptionsPosition[      6412,        194]
NotebookOutlinePosition[      7004,        215]
CellTagsIndexPosition[      6961,        212]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"tocke0", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0.06", ",", " ", 
      RowBox[{"-", "0.02256"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.03", ",", " ", 
      RowBox[{"-", "0.0007284"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0.0", ",", " ", "0.02062"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.03"}], ",", " ", "0.04282"}], "}"}]}], "}"}]}]], "Input",\

 CellChangeTimes->{{3.489749921840193*^9, 3.489749998968646*^9}, 
   3.489750270173137*^9},
 Magnification->1.5],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.06`", ",", 
     RowBox[{"-", "0.02256`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.03`", ",", 
     RowBox[{"-", "0.0007284`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.02062`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.03`"}], ",", "0.04282`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.489750000541087*^9, 3.4897500588119*^9, 
  3.489750270659087*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tocke", " ", "=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "&"}], ",", "tocke0"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.48975027501147*^9, 3.489750293004749*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.02256`"}], ",", "0.06`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0007284`"}], ",", "0.03`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.02062`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.04282`", ",", 
     RowBox[{"-", "0.03`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.489750293614977*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit", " ", "=", " ", 
  RowBox[{"FindFit", "[", 
   RowBox[{"tocke", ",", 
    RowBox[{
     RowBox[{"c", "*", "x"}], " ", "+", " ", "d"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.489750060365598*^9, 3.48975009035333*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"c", "\[Rule]", 
    RowBox[{"-", "1.3793121696216981`"}]}], ",", 
   RowBox[{"d", "\[Rule]", "0.028845397627445642`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.489750090762992*^9, 3.48975029578388*^9, 
  3.489750388184145*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", 
    RowBox[{"tocke", ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Hue", "[", "0", "]"}], ",", 
        RowBox[{"PointSize", "[", "0.02", "]"}]}], "}"}]}]}], "]"}], ",", " ",
    
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "0.04"}], ",", "0.07"}], "}"}]}], "]"}], ",", 
   RowBox[{"AxesLabel", "->", 
    RowBox[{"{", 
     RowBox[{"\"\<Difference\>\"", ",", "\"\<Offset\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.48975009683483*^9, 3.489750204350642*^9}, {
  3.489750307792322*^9, 3.489750339091915*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0], PointSize[0.02], 
     PointBox[{{-0.02256, 0.06}, {-0.0007284, 0.03}, {0.02062, 0.}, {
      0.04282, -0.03}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVx3s403scwHFG6YqUS5LrKUNKoiL1SU9F57BsuTz1SG6ROqTLVEupKVG6
DYtQmy0x0n7Wkh726cg5lkWkOkihlXvRRXkqOd/zx/t5Py+r8L2snTQNDQ0G
6f97Je106eaI0Wn4zG/OXDkwiiyc2AlirBPWxi9IkoN/c5vD1P1i3O6vWW2S
KIdQG4bN0hgxnq3kBEyw5XC4brnBySAxqpNjUx7HyEGiN2XE0kWMV0y29EUx
5TBDICkJfS/Cn57mpbmWcmh6MGzdtUOEysw7yybhHQjgRU2f5ViAHbZ6R2MH
ZZBerXzN1xXiXm5T8MsFMjAt5uYkDF5HOvUu3C6yHAy/+cTYnM3HkAa6cAaP
ggNj73U5zFw0oJ4eGW2QwqO5u4pc+rORqx1g2PvpNtwx0Du0KJ2PTptLk0TM
MqBh+rzGoExspzeb73lcCpvOqWUtny/j0VfMxdsXlsA7Q+v1k/ddRBMrwf5t
ecUQVvvibKf+OdSeyZ8wNi2CxvLVlSeYKdjX0vtzIqEQaFNYGWz1SVTa6Sz5
PCwGhvtSSeQiDgq2cZv1vUUwWLOP1qKIx7plN6o+3BSCb6SLsuDJDhzIzer4
10YAxrpLh82C3GCq4mHbi/E84Lc7fdw0Fgku4d8i5gzlQPOmNpa31UHwq3rT
WJjNB21lVGtCzjGYHj1fVemfAQFVPlpJK5JBseSzk9r7Etx7JivnaKZCVbDm
cM3XNPBPib1rzUmHD1mszUOqZIio7bGlx12CB12nxI4njoL4RrXGy0Ye3GtP
2Vb68E/gtlRrvZ2cBYILB9Q15p4Q3f3WIC3uCvRF6KlFnlFYYdw5NFKfAx4Z
a78fsT2M4qu0j2W/ciHw+MbFbxdyMWfcR3Nq+DVY7DWeH1adivzArvxghgBM
nx1zL1dfwMyaZEujKCF0dy5pP8HmIf+ae3F+VgHUWcTcbbmfhb2Wk72apCKo
8NSx01dm46rZ7waa1GKouPX+/jejPHxd0ipKpBUC/lipVjpex4pW15q0eTch
M9G0Ot1UiBnswp5InyJgCTyyp2EBKu45WA7uKgYD18trjnmJcWhP7Q7Il0DH
h7SDf4/cQD/ZP9qjqhII1HgZ5su7iVrCV4qAnlJ4wQ0xrTcuxspfOkmnTMog
2D4l3EwhQQXNyz9k+W3oW9fFjvAuxcSGQ3U+tlKwlvHWDtTfwtzm59FMlEKU
d//VjXG3sZuu4Dn4UhBk69al4kjRbqX0wVAPBRNVT9w7GRRG1WlaTxBPoQ9k
jhEXBG5JntVLgX6G9vCszRSasb9uWE5sE+MmWk+sW+6hSiLeYCiaLiH+4vDo
uUEfBedjEzoO+lGosHgzsLKfgrnm849PY1H4vWyZzx/EVmkrWm2IV6w5fWs7
sf0XpvNqYmkwPZ5L7FGf0rOXWJQTN6oiDk0YYTwnTp39YyJkgILCxocWgi0U
1hb4hO0jLnN7faSSWNP5Wk0ycYV4rOUpMcfP83QRsZLjmDrJn8LY82emfSIe
WnhlZDexxKxtj/YgBaOXqd9PEfeU2DcYEY//VInziUPrGy6uItZv0djaRJy3
1eKjL7HJmnmyfuK2vnhWKLFVsetMrQAKjQ7XyPYT28/xizYjZunMMTxN7Jy0
+y9X4v8Ap9KC3w==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"Difference\"", TraditionalForm], 
    FormBox["\"Offset\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  PlotRange->{{-0.02256, 0.04282}, {-0.03, 0.06}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.489750145783075*^9, 3.489750204497088*^9}, 
   3.489750298131734*^9, 3.489750339658412*^9, 3.489750389402947*^9}]
}, Open  ]]
},
WindowSize->{1083, 801},
WindowMargins->{{Automatic, 39}, {Automatic, 52}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"Magnification"->1.,
"PaperOrientation"->"Portrait",
"PaperSize"->{611.25, 789.5625},
"PostScriptOutputFile"->"/home/miham/Hive/JLab/e05102/Optics4/\
TargetPhCalibration/elasticalignment.nb.ps"},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 573, 18, 40, "Input"],
Cell[1166, 43, 483, 15, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1686, 63, 388, 12, 28, "Input"],
Cell[2077, 77, 438, 14, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2552, 96, 320, 8, 28, "Input"],
Cell[2875, 106, 279, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3191, 118, 804, 24, 28, "Input"],
Cell[3998, 144, 2398, 47, 224, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
