(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     21988,        607]
NotebookOptionsPosition[     20246,        541]
NotebookOutlinePosition[     20581,        556]
CellTagsIndexPosition[     20538,        553]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Slope Correction", "Section",
 CellChangeTimes->{{3.485586512914893*^9, 3.485586516451657*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Tocke", "  ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.8", ",", " ", "0.6421"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.0", ",", " ", "0.7969"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.1", ",", " ", "0.8743"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.2", ",", " ", "0.9504"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.3", ",", " ", "1.023"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.4", ",", " ", "1.099"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", " ", "1.169"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1.8", ",", " ", "1.411"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"2.0", ",", " ", "1.571"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4855681732749*^9, 3.485568294905122*^9}},
 Magnification->1.5],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", "Tocke", "]"}]], "Input",
 CellChangeTimes->{{3.485568298382043*^9, 3.485568311121537*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, 
   {Hue[0.67, 0.6, 0.6], 
    PointBox[{{0.8, 0.6421}, {1., 0.7969}, {1.1, 0.8743}, {1.2, 0.9504}, {1.3,
      1.023}, {1.4, 1.099}, {1.5, 1.169}, {1.8, 1.411}, {2., 1.571}}]}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.8, 0.8},
  PlotRange->{{0.8, 2.}, {0.6421, 1.571}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.485568312010511*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit1", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"Tocke", ",", " ", 
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.485568331906231*^9, 3.485568351010144*^9}, {
  3.485568398675588*^9, 3.48556840278525*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"c", "\[Rule]", "0.770099426386233`"}], ",", 
   RowBox[{"d", "\[Rule]", "0.024277437858509183`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.485568351376557*^9, 3.485568403185842*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "Tocke", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit1"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0.75", ",", "2.05"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.48556840604603*^9, 3.485568437787262*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0.67, 0.6, 0.6], 
     PointBox[{{0.8, 0.6421}, {1., 0.7969}, {1.1, 0.8743}, {1.2, 0.9504}, {
      1.3, 1.023}, {1.4, 1.099}, {1.5, 1.169}, {1.8, 1.411}, {2., 
      1.571}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVz30w1HkABvAVtmEQHbaXo+j15MptW5rz8qzlTrWV8ZLyNkpekilUV3lp
a++w9oRKGRw1RG0d0YuXUI1EV5IlTDqls3XWy8auffvJ6r73xzPPfP57HruI
eL+oeTQabRfJ/z0Z6G5Go0khdGFtCOdI4GXgw/LSl6JxxGaJxEuCojvhwZl0
KSby5hvGeEvwswn/urmpFD4Tb98e2SFBcUuru90SKaxK+Bm8QAm2O26L57Ck
KJ179a7kkATlegHitINSNLTEnhu8KMHeytiLRt1SjHhfHQ2SSPC31CJEdG8U
2VUnzYcufIRtq00hRzCG6yFHha9Zn3DJn+1aFziOzj2iu5d7P2Flx9CKx84T
cK/ibh3m/4vjH4bPthrJYMe1cLqyYgTvByPsw2Qy7OJ4pX3sGUFKLrVW/PIz
hIK7mVqeFG+GpsvdSybhbOU5lLJsFKKsWmYpprB+ll0m7ByFl7qsc/nNKRSs
219PTxjDTNPSpdnmciy82Zzqu2Acbqoe46dn5eg7k357dfM49ulcak+NymF8
NYEZFzYB8ySJnjZYASHjuf2PJjIM+FjrRb5QwOp9aGt/vQy/qmYadzKnYSlb
WDe85zMazGwZ865NI3T3Zqskw0m8Uiu+Z5kowaCntvNuTCLRjz7ixFPCNJNx
VLCO7DSq8FvyWQnr+2ZBdfwpdOSoTvEDVQgyYIx+2zMFlSDN494zFTz0Aqu3
fifHnE/b04gf1Nhvf922MlkOu2MXZuYK1BCOfRN94oUc3UbFPVFGGuwOb5AY
2imwP35v1PajGoRoDxt3JirA2+pfREk0MHQPjgl6rkBt6gD/sr8W9Q6RxTuW
TaPjjMXK6iYtSl3OJJ+Mn8YRteBgniMFJ0qcE9M+DblLTYzqMgXt2407chlK
5AweWOylo/DXgfv/2MQo0TC1+3DY4Rm4FcZVJT5U4slrKkXZN4NxxUZ7nSn5
5TDoGOj9BW4Us3NnlApin4SCTXe+4PkKT7v+OhX2iXPr9BbPIkSVsLONrsbp
p7ITBcJZ5B3rq04KUyNZoJNXKmahb81tirqthsEj7oJzkTositLMWtM1EPms
GtrTq8OmkBbrDaEaONbUxJa6ziHrl+IBXqUGbmnJ+bVVc8hwvd2Tp6/F+jXq
096Mr3iwpvv4hwAttqzSMdp5X6F8YDGZV65FVz4nYMHkV/RqM6+afNHi2njx
qvF1NLYsxIJq5lKoaHNW3IuksW/FiTOZ1yj0eMw0NRLjJx+dK/Hcw+b0FuIe
21eJ3sSBdR6Lu4ip7o7gUGL6DS57jNh7yzPHDOLozPCc5VE09rDBI/EA8Vqu
wCGbeOmVPxfxyykEPNumzCOuPumQnUV81tPkURExx/emXj7xG5cLviLiWIMb
Y7eIMx3/ONVKXHeorLmXeNS0up0i9ncu3Le2goL174nnadE0ttR8UR+TmENn
Bc8nThnL3+ZGXDTXILMkLiu5xPQj3j75xNKJeEr/vEEq8Ym49PebiX97Z5aU
QVw24i1yI2bUZ8vOE88MvXThErsdyuqvIF4dmmvoR9ztacytIfZ749u1lzjS
Rvi4kZgXYFkYTqxVz2e1Ed8S90dEE2eJM0RdxP8BJSxwJg==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.8, 0.8},
  ImageMargins->{{0., 47.}, {36., 0.}},
  ImageSize->{448., Automatic},
  PlotRange->{{0.8, 2.}, {0.6421, 1.571}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.48556843884879*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TockeInv", "=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "&"}], ",", "Tocke"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.485568490409137*^9, 3.485568528645794*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.6421`", ",", "0.8`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7969`", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8743`", ",", "1.1`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9504`", ",", "1.2`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.023`", ",", "1.3`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.099`", ",", "1.4`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.169`", ",", "1.5`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.411`", ",", "1.8`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.571`", ",", "2.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.485568519879719*^9, 3.485568529246308*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit2", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"TockeInv", ",", " ", 
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.485568538094569*^9, 3.485568563230352*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"c", "\[Rule]", "1.2981740075518504`"}], ",", 
   RowBox[{"d", "\[Rule]", 
    RowBox[{"-", "0.031144006424414467`"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.485568541640516*^9, 3.485568563706706*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "TockeInv", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit2"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0.75", ",", "2.05"}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.485568549047279*^9, 3.485568551748936*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0.67, 0.6, 0.6], 
     PointBox[{{0.6421, 0.8}, {0.7969, 1.}, {0.8743, 1.1}, {0.9504, 1.2}, {
      1.023, 1.3}, {1.099, 1.4}, {1.169, 1.5}, {1.411, 1.8}, {1.571, 
      2.}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVx38803kcwPHvNnMmqe7E0dWlksVKpKPQ+0MeiAcOayHi1ihFkktSdik1
PxKVSk5dP5TpoaOccpbuIb+60vmZh18PevC4h0mbbbax2Xfuc3+8Hq/H05qb
HBpHJQgiCPf/Zzi7TAlCDPfyx7MHmVLwNgh29qaJ4exCkM58sxRKn8VE5hiK
IeKoKJXtKAUfk6zHy5eKwSygmNu5QwplTc27rK3EcMnYB7X6S8GftSfZy1kM
x3IrF2oSpVBOYXdlHxaDm+D4iZwaKYRXJVxjdIvh43l9jIvrDAyLV+wX1k7B
9+XxbGcHGaxpXn3bS/AZEvf+Liiol0FxGHJ/wZkGW6M+ynaQw4b3Y+v/cvkC
pHWvk0+3HH7+NH6umSGBI3nPFbciFDA6wl0XLZGAIuJoQphEAWcKNcyuDilM
2VFto/mzMDA2W77rzgyc8j+dWkFXgjC/zuk+yGBt999p+0uU4K1+8GFtpQy4
j7VGP1qrQCtatapguRy+zmSMX6tQgYeqx7jlnBxGGuQpsEMNsaRbXfqUHMC3
oYjVpIblpyco85EKaNwZFX+BPQeDweYU3jsFVDiMnGf+OwfnVdqGQKdZsEt1
32KaOA/1pmssqA9noX11WlG0fh7+USs2O5sogTQvypJc0kBKqOHkVr4SAk9d
2DRppYUtjEehVlIlLBlkf+tQpYX3V1TpWRwVcHMNb77ctgAqQbZnbbsKeu9d
fVfZtgD64NYWrqMahg3JgpFgHVinXtXqS9QQesynJLpfB92Msp44xhxMuCdE
+B0m4afk8Dj/E3OwNDKxMlVGAt8vrFQzMQcho341Rtl6qDs7mHUjbB5oPJp+
2mwR3v+yYkO1aB4CXe8OLStbhGNqweHrLA0M7GC8DLIgkNyt5pDqhgb6+dve
1u0n0JWRg5bepAbyWzp0zXcJVC/bmxSdpIUPjT0mgkkCvenVnFF+1ELUqB/v
iD0FRdiNsDi+C5D+3P4W9SQFdQUfL9n+bAE+PeWvEP1JQbFdhS8oljrQV6Jq
K5KCMlskaSW5OngSkcx08KGiDAEpr1Lo4MFW06mDeVRk8Dpg2WUeCUyR5cXA
PioSBtuM7esjgedT7D36HQ2xamoS7rvrQTLPDyiMpSGP7IybdU/1QIvp36yq
pKEttupMX4tF4H25s++MlIZcbUiLNv4iZGb0lQsdDVDnTS/2splFWP/q1Ie8
DAP0cLrMZtqeQCtt8j0KXhugR60uiloegYo9l+R6G9FRj6dW1IC9KVoVHoit
b3x1sQn7VfoYk4PNeeFp2Yk9UV379hC2YUUA+oztuCbKKB87Pifmyto4AnVo
qwTd2MwAgV0BNv2PoEsHGHTEbt+jvI59u9OVcwj73G6T16XYrOl1G49jD7hd
DRFih62ba83CzmH9mt6Mfb/oN/oj7Kml1W0abI8kWfY0tnleShERT6CenCG2
EtvL0DnyK+y48pYNJHapvl5ihn15uKTF1JiO/GfemG3FHtrjaeCEnXb04ugP
2Elx9n07sR9M+go9sClZK8t3Y2vHOtwCsJn1U7v3Ym+MKqSHYot6e785gB06
ENIZjh000zgRj81nm92OwR43FtYmYz/p6ufGY5/ceO1COvZ/eDU+QQ==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.8, 0.8},
  PlotRange->{{0.6421, 1.571}, {0.8, 2.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.485568553215668*^9, 3.485568565404325*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FinalResult", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit2"}], "/.", 
   RowBox[{"x", "\[Rule]", "1"}]}]}]], "Input",
 CellChangeTimes->{{3.485568633346977*^9, 3.485568659849566*^9}}],

Cell[BoxData["1.267030001127436`"], "Output",
 CellChangeTimes->{{3.485568648460201*^9, 3.48556866066377*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Offset Correction", "Section",
 CellChangeTimes->{{3.48558653161385*^9, 3.485586535650368*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TockeOffset", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.0", ",", " ", "0.02026"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.01", ",", " ", "0.01256"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.015", ",", " ", "0.008719"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.02", ",", " ", "0.004844"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.025", ",", " ", "0.0006719"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.03", ",", " ", 
       RowBox[{"-", "0.003246"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.04", ",", " ", 
       RowBox[{"-", "0.011"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.05", ",", " ", 
       RowBox[{"-", "0.01887"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.06", ",", " ", 
       RowBox[{"-", "0.02695"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.48558654352221*^9, 3.485586645106877*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TockeOffsetInv", "=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "&"}], ",", "TockeOffset"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.485586651257556*^9, 3.485586668764604*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.02026`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.01256`", ",", "0.01`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.008719`", ",", "0.015`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.004844`", ",", "0.02`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0006719`", ",", "0.025`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.003246`"}], ",", "0.03`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.011`"}], ",", "0.04`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.01887`"}], ",", "0.05`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.02695`"}], ",", "0.06`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.485586669230469*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit3", "=", 
  RowBox[{"FindFit", "[", 
   RowBox[{"TockeOffsetInv", ",", " ", 
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], ",", 
    RowBox[{"{", 
     RowBox[{"c", ",", "d"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.485568538094569*^9, 3.485568563230352*^9}, {
  3.48558668074957*^9, 3.485586683889843*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"c", "\[Rule]", 
    RowBox[{"-", "1.2700283211995038`"}]}], ",", 
   RowBox[{"d", "\[Rule]", "0.025941726056671235`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.485568541640516*^9, 3.485568563706706*^9}, 
   3.485586685596103*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "TockeOffsetInv", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit3"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "0.03"}], ",", "0.03"}], "}"}]}], "]"}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.485568549047279*^9, 3.485568551748936*^9}, {
  3.485586692338475*^9, 3.485586709636384*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, 
    {Hue[0.67, 0.6, 0.6], 
     PointBox[{{0.02026, 0.}, {0.01256, 0.01}, {0.008719, 0.015}, {0.004844, 
      0.02}, {0.0006719, 0.025}, {-0.003246, 0.03}, {-0.011, 0.04}, {-0.01887,
       0.05}, {-0.02695, 0.06}}]}, {}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1G00lAkUB/Ah0ZYsm+xUKu1aDaHSlJxebrv04qWJWYZsIaUIZcqOl6Gd
BnnSxDDDGKanF8VoiimKHdUtba2MkEpKyVsyuxKtNmlOu8+esx/u+Z/fOffD
/fK/C8L3syMMaTQai5r/8u4tfrtfLYlNg4mz6BFqIL3pukNVJKY8DKSJd6qB
97j6k6qCRMcbK16bhKvBTvfGxvgciSLJWPWHEDVkmodFa3JJ9F4b5/skSA2b
Qj1o30aT2CjZk1ngo4ZGvanD2FwSG9Zy3lsy1dDiSqYWpJ3AeumyBxaT1JDd
Pn9eH1OB5KILyfKllWD3xKl9u74IV9QwPttGV0AP32z04z05ZjpqrPKVF4Ht
yZpMphaikc+cwszHF0CROHtp3EYZGryv+i3HnHLreo7Xh3x02GQdPHuVCrDJ
vWv9RSmaZsjTj0adhzqH5tT9SRKM9WYFm5WWQ+ylGqvTi/Jwoq6tcGabEsbl
Tr/TxsRocjVb6GKqBO/NQ9WTMnKwSR5qwPQqgxm1q5pnDovwxkKariahFI4P
lFilp2XhEujg+1Wdg4O7G/0MX2XifZogIbbrLJDOBezb7Ay0vbB6yr7pZyFZ
kyzsHhLix+4lHuleJVAvm3tu+o8CnMCxQeuEM5DEvfzGScvHFMbISu2l07CR
U8oLI3jIWFU3+qnzFJzS9mfRQ7iY7VoMFlNPQa24fMJiVhQOJkdwE0Uk3D45
OSDCZztO61y2/GGfAjYk6IPNJe7ozOJu2RpYDGVN1+WpFT9AvbRDomyTw0CK
59IjX4dAxeKX5XrHQvh7gmfG00SC/IW/VUpJAfSNlyniFVx4/jLKn/ZRCrf6
7pUybvNAfEV5bTNHAqs3ati2uXzwIDn8uy258HaSzFSwUwC+nSXTPBhiyLap
vWnRJoSrnJv9T92Og25sWWUYMwMqT4iMb7hkQXvC6PmTjZmw9bhMq9Idga9c
CxKEzCyglQjWjHSkQe/ZFL+ANhFwdijZa48IgLbFS691z4GgY9vs7z5Jhtig
X0d+eSSGhtNfcpj18VASNqyzWJAHS2YI8qL9YsDARKb9OVAC4veXg/L+CQVl
enfVgzIp0Oxj5HtdloNTSKCb6bt8GCkPjWrU+ePTx9+X0e1kQJdZfnG9Yje2
2N6fMze+ENb9BAzXcS4OWTQl/qWSw8i8lQfCGYk4EDx+QPmiCLqlR2dEuR1C
B/6dgwH2Cqh+7uzqvEeI+W7G2x+FnAB9g8bVLykDvVpe+3hXkCA1nZK/9z6B
lvPN9hykLDI/w22l3LWPebiYcrrlataKZgIPmB2+8ifleOs4E8MWAos2z54n
qiTB17EjSd5KoE7r87ZJTYKRjzKk4SGBRMOlXFYVtX9sE8PuGYFseoeKRzkm
p9dIRNk68vMdkvIuSUrPKGW1iffEMGXfYnXR9U4COzb0h+dUk+Cook8PeEHg
wjtWzNYrJPQ3Do6mdRM4YrmGNU65o1nYrKOs2bUz0uYqCa1t1qotPQSyjNSK
OMrXnvnumtNLIM/dc7JFDQmKP2rbL/cRuE6yf74bZfEwu4reT+DUvny3HZSJ
d0M5hyiTwl6qkiQkTth4er0iMLJtCvGUcsxnzXdqyi7fLD5jUEvdbxhgaDVA
oJ4bcM2e8jbjt118yv//M/CferSuh/K/AfF4Og==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-0.02695, 0.02026}, {0., 0.06}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.485568553215668*^9, 3.485568565404325*^9}, 
   3.48558671058406*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FinalResult", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"c", "*", "x"}], "+", "d"}], "/.", "fit3"}], "/.", 
   RowBox[{"x", "\[Rule]", "0"}]}]}]], "Input",
 CellChangeTimes->{{3.485568633346977*^9, 3.485568659849566*^9}, {
  3.48558671911895*^9, 3.485586723152668*^9}}],

Cell[BoxData["0.025941726056671235`"], "Output",
 CellChangeTimes->{{3.485568648460201*^9, 3.48556866066377*^9}, 
   3.485586723768375*^9}]
}, Open  ]],

Cell[BoxData["histogram"], "Input",
 CellChangeTimes->{{3.485595502821469*^9, 3.485595507104955*^9}}]
}, Open  ]]
},
WindowSize->{961, 911},
WindowMargins->{{111, Automatic}, {Automatic, 24}},
FrontEndVersion->"6.0 for Linux x86 (32-bit) (April 20, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 101, 1, 72, "Section"],
Cell[694, 26, 906, 24, 87, "Input"],
Cell[CellGroupData[{
Cell[1625, 54, 131, 2, 40, "Input"],
Cell[1759, 58, 499, 13, 232, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2295, 76, 355, 9, 40, "Input"],
Cell[2653, 87, 234, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2924, 97, 399, 12, 40, "Input"],
Cell[3326, 111, 2293, 45, 324, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5656, 161, 381, 12, 40, "Input"],
Cell[6040, 175, 724, 21, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6801, 201, 310, 8, 40, "Input"],
Cell[7114, 211, 257, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7408, 222, 403, 12, 40, "Input"],
Cell[7814, 236, 2254, 43, 250, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10105, 284, 258, 7, 40, "Input"],
Cell[10366, 293, 110, 1, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10525, 300, 101, 1, 72, "Section"],
Cell[10629, 303, 960, 27, 87, "Input"],
Cell[CellGroupData[{
Cell[11614, 334, 393, 12, 40, "Input"],
Cell[12010, 348, 812, 25, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12859, 378, 364, 9, 40, "Input"],
Cell[13226, 389, 283, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13546, 401, 480, 14, 40, "Input"],
Cell[14029, 417, 5600, 100, 250, 2266, 43, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19666, 522, 306, 8, 40, "Input"],
Cell[19975, 532, 139, 2, 28, "Output"]
}, Open  ]],
Cell[20129, 537, 101, 1, 40, "Input"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
